import java.util.*;
import java.io.*;
import java.lang.Object;
import java.lang.Thread;

class Node
{
    private int index;
    private String ID;

    private int indexP;

    private int indexC [];
    private int nbChildren;

    private int peer;

    private int load;

    public int nbFilsTraites; // crad (pour parcours en profondeur)

    // Construit un noeud avec un identifiant
    Node (String _ID)
    {
	ID = _ID;
	indexP = -1;
	nbChildren = 0;
	indexC = new int [95]; // Number of children : number of characters
	for (int i = 0; i < 95; i++)
	    indexC[i] = -1;

	peer = -1;
	load = 0;

	nbFilsTraites = 0;
    } // Noeud

    /**
     * Map the node on a ring
     * @param ring on which the node is to be inserted
     * @return void
     */
    public void map (Ring ring)
    {
	// finding first peer after origin
	int origin = 0; // by default
	for (int i = 0; i < ring.getNbPeers()-1; i++)
	    {
		if (ring.peers[i].getID().compareTo(ring.peers[i+1].getID()) > 0)
		    {
			origin = i+1;
			break;
		    }
	    }
	
	int index = origin;
	for (int i = 0; i < ring.getNbPeers(); i++, index++)
	    {
		if (index == ring.getNbPeers())
		    index = 0;
		
		if (ring.peers[index].getID().compareTo(ID) >= 0)
		    break;
	    }
	
	if (index == ring.getNbPeers()) // arrive !seulement! quand index == i == nbPairs
	    this.setPeer(0);
	else
	    this.setPeer(index);
    } // map

    public void incLoad ()
    {
	load++;
    }

    public void resetLoad () 
    {
	load = 0;
    }
    
    public void setIndex(int _index)
    {
	index = _index;
    }

    public int getIndex()
    {
	return (index);
    }

    public void setID(String _ID)
    {
	ID = _ID;
    }

    public void setParent(int _indexP)
    {
	indexP = _indexP;
    }

    public void addChild(int newC)
    {
	indexC[nbChildren++] = newC;
    }

    public void setChild(int ind, int newChild)
    {
	indexC[ind] = newChild;
    }

    public String getID()
    {
	return(ID);
    }

    public int getParent()
    {
	return (indexP);
    }

    // Recupere l'indice (ID) du fils contenu  l'indice ind (du tableau des fils)
    public int getThisChild(int ind)
    {
	return (indexC[ind]);
    }
    
    public int [] getChildren()
    {
	return (indexC);
    }

    public int getNbChildren()
    {
	return(nbChildren);
    }

    public void setPeer(int _peer)
    {
	peer = _peer;
    }    
    
    public int getPeer()
    {
	return (peer);
    }
    
    public void setLoad(int _load)
    {
	load = _load;
    }
    
    public int getLoad()
    {
	return(load);
    }

} // Noeud
