import java.util.*;
import java.io.*;
import java.lang.*;

class Simulator
{
    private Tree tree;
    private Ring ring;

    private String [] objects;
    private int nbObjects;

    private double loadFactor;

    private String [] insertedObjects;
    private int nbInsertedObjects;
    
    public double round(double what, int howmuch) {
        return (double)( (int)(what * Math.pow(10,howmuch) + .5) ) / Math.pow(10,howmuch);
    }
    
    Simulator()
    {
	
	String services [] = new String [735];
	int nbServices = 0;
    
	//************** S3L **************

	services[nbServices++] = new String ("S3L_mat_mult");
	services[nbServices++] = new String ("S3L_mat_mult_noadd");
	services[nbServices++] = new String ("S3L_mat_mult_addto");
	services[nbServices++] = new String ("S3L_mat_mult_t1");
	services[nbServices++] = new String ("S3L_mat_mult_t1_noadd");
	services[nbServices++] = new String ("S3L_mat_mult_t1_addto");
	services[nbServices++] = new String ("S3L_mat_mult_h1");
	services[nbServices++] = new String ("S3L_mat_mult_h1_noadd");
	services[nbServices++] = new String ("S3L_mat_mult_h1_addto");
	services[nbServices++] = new String ("S3L_mat_mult_t2");
	services[nbServices++] = new String ("S3L_mat_mult_t2_noadd");
	services[nbServices++] = new String ("S3L_mat_mult_t2_addto");
	services[nbServices++] = new String ("S3L_mat_mult_h2");
	services[nbServices++] = new String ("S3L_mat_mult_h2_noadd");
	services[nbServices++] = new String ("S3L_mat_mult_h2_addto");
	services[nbServices++] = new String ("S3L_mat_mult_t1_t2");
	services[nbServices++] = new String ("S3L_mat_mult_t1_t2_noadd");
	services[nbServices++] = new String ("S3L_mat_mult_t1_t2_addto");

	services[nbServices++] = new String ("S3L_matvec_sparse");
	services[nbServices++] = new String ("S3L_lu_factor");
	services[nbServices++] = new String ("S3L_fft");
	services[nbServices++] = new String ("S3L_ifft");
	services[nbServices++] = new String ("S3L_rc_fft");
	services[nbServices++] = new String ("S3L_cr_fft");
	services[nbServices++] = new String ("S3L_fft_detailed");
	services[nbServices++] = new String ("S3L_gen_band_factor");
	services[nbServices++] = new String ("S3L_gen_trid_factor");
	services[nbServices++] = new String ("S3L_sym_eigen");
	services[nbServices++] = new String ("S3L_rand_fib");
	services[nbServices++] = new String ("S3L_rand_lcg");
	services[nbServices++] = new String ("S3L_gen_lsq");
	services[nbServices++] = new String ("S3L_gen_svd");
	services[nbServices++] = new String ("S3L_sort");
	services[nbServices++] = new String ("S3L_sort_up");
	services[nbServices++] = new String ("S3L_sort_down");
	services[nbServices++] = new String ("S3L_grade_up");
	services[nbServices++] = new String ("S3L_grade_down");
	services[nbServices++] = new String ("S3L_sort_detailed_up");
	services[nbServices++] = new String ("S3L_sort_detailed_down");
	services[nbServices++] = new String ("S3L_grade_detailed_up");
	services[nbServices++] = new String ("S3L_grade_detailed_down");
	services[nbServices++] = new String ("S3L_trans");
    
	//************** Scilab ***************

	services[nbServices++] = new String ("aff2ab");
	services[nbServices++] = new String ("balanc");
	services[nbServices++] = new String ("bdiag");
	services[nbServices++] = new String ("chol");
	services[nbServices++] = new String ("coff");
	services[nbServices++] = new String ("colcomp");
	services[nbServices++] = new String ("companion");
	services[nbServices++] = new String ("cond");
	services[nbServices++] = new String ("det");
	services[nbServices++] = new String ("ereduc");
	services[nbServices++] = new String ("exp");
	services[nbServices++] = new String ("expm");
	services[nbServices++] = new String ("fstair");
	services[nbServices++] = new String ("fullrf");
	services[nbServices++] = new String ("fullrfk");
	services[nbServices++] = new String ("givens");
	services[nbServices++] = new String ("glever");
	services[nbServices++] = new String ("gschur");
	services[nbServices++] = new String ("gspec");
	services[nbServices++] = new String ("hess");
	services[nbServices++] = new String ("householder");
	services[nbServices++] = new String ("im_inv");
	services[nbServices++] = new String ("inv");
	services[nbServices++] = new String ("kernel");
	services[nbServices++] = new String ("Kroneck");
	services[nbServices++] = new String ("linsolve");
	services[nbServices++] = new String ("lu");
	services[nbServices++] = new String ("lyap");
	services[nbServices++] = new String ("nlev");
	services[nbServices++] = new String ("orth");
	services[nbServices++] = new String ("pbig");
	services[nbServices++] = new String ("pecan");
	services[nbServices++] = new String ("penlaur");
	services[nbServices++] = new String ("pinv");
	services[nbServices++] = new String ("polar");
	services[nbServices++] = new String ("proj");
	services[nbServices++] = new String ("projscpec");
	services[nbServices++] = new String ("psmall");
	services[nbServices++] = new String ("qr");
	services[nbServices++] = new String ("quaskro");
	services[nbServices++] = new String ("randpencil");
	services[nbServices++] = new String ("range");
	services[nbServices++] = new String ("rank");
	services[nbServices++] = new String ("rcond");
	services[nbServices++] = new String ("rowcomp");
	services[nbServices++] = new String ("rowshuff");
	services[nbServices++] = new String ("rref");
	services[nbServices++] = new String ("schur");
	services[nbServices++] = new String ("spaninter");
	services[nbServices++] = new String ("spanplus");
	services[nbServices++] = new String ("spantwo");
	services[nbServices++] = new String ("spec");
	services[nbServices++] = new String ("sqroot");
	services[nbServices++] = new String ("sva");
	services[nbServices++] = new String ("svd");
	services[nbServices++] = new String ("sylv");
	services[nbServices++] = new String ("trace");
	
	//********** BLAS ************

	services[nbServices++] = new String ("SROTG");
	services[nbServices++] = new String ("DROTG");
	services[nbServices++] = new String ("SROTMG");
	services[nbServices++] = new String ("DROTMG");
	services[nbServices++] = new String ("SROT");
	services[nbServices++] = new String ("DROT");
	services[nbServices++] = new String ("SROTM");
	services[nbServices++] = new String ("DROTM");
	services[nbServices++] = new String ("SSWAP");
	services[nbServices++] = new String ("DSWAP");
	services[nbServices++] = new String ("CSWAP");
	services[nbServices++] = new String ("ZSWAP");	
	services[nbServices++] = new String ("SSCAL");
	services[nbServices++] = new String ("DSCAL");
	services[nbServices++] = new String ("CSCAL");
	services[nbServices++] = new String ("ZSCAL");
	services[nbServices++] = new String ("CSSCAL");
	services[nbServices++] = new String ("ZDSCAL");
	services[nbServices++] = new String ("SCOPY");
	services[nbServices++] = new String ("DCOPY");
	services[nbServices++] = new String ("CCOPY");
	services[nbServices++] = new String ("ZCOPY");
	services[nbServices++] = new String ("SAXPY");
	services[nbServices++] = new String ("DAXPY");
	services[nbServices++] = new String ("CAXPY");
	services[nbServices++] = new String ("ZAXPY");	
	services[nbServices++] = new String ("SDOT");
	services[nbServices++] = new String ("DDOT");
	services[nbServices++] = new String ("DSDOT");
	services[nbServices++] = new String ("CDOTU");	
	services[nbServices++] = new String ("ZDOTU");
	services[nbServices++] = new String ("CDOTC");
	services[nbServices++] = new String ("ZDOTC");
	services[nbServices++] = new String ("SNRM2");	
	services[nbServices++] = new String ("DRRM2");
	services[nbServices++] = new String ("SCNRM2");
	services[nbServices++] = new String ("DZNRM2");
	services[nbServices++] = new String ("SASUM");	
	services[nbServices++] = new String ("DASUM");
	services[nbServices++] = new String ("SCASUM");
	services[nbServices++] = new String ("DZASUM");
	services[nbServices++] = new String ("ISAMAX");
	services[nbServices++] = new String ("IDAMAX");
	services[nbServices++] = new String ("ICAMAX");
	services[nbServices++] = new String ("IZAMAX");

	services[nbServices++] = new String ("SGEMV");
	services[nbServices++] = new String ("DGEMV");
	services[nbServices++] = new String ("CGEMV");
	services[nbServices++] = new String ("ZGEMV");
	services[nbServices++] = new String ("SGBMV");
	services[nbServices++] = new String ("DGBMV");
	services[nbServices++] = new String ("CGBMV");
	services[nbServices++] = new String ("ZGBMV");
	services[nbServices++] = new String ("CHEMV");
	services[nbServices++] = new String ("ZHEMV");
	services[nbServices++] = new String ("CHBMV");
	services[nbServices++] = new String ("ZHBMV");
	services[nbServices++] = new String ("CHPMV");
	services[nbServices++] = new String ("ZHPMV");
	services[nbServices++] = new String ("SSYMV");
	services[nbServices++] = new String ("DSYMV");
	services[nbServices++] = new String ("SSBMV");
	services[nbServices++] = new String ("DSBMV");
	services[nbServices++] = new String ("SSPMV");
	services[nbServices++] = new String ("DSPMV");
	services[nbServices++] = new String ("STRMV");
	services[nbServices++] = new String ("DTRMV");
	services[nbServices++] = new String ("CTRMV");
	services[nbServices++] = new String ("ZTRMV");
	services[nbServices++] = new String ("STBMV");
	services[nbServices++] = new String ("DTBMV");
	services[nbServices++] = new String ("CTBMV");
	services[nbServices++] = new String ("ZTBMV");
	services[nbServices++] = new String ("STPMV");
	services[nbServices++] = new String ("DTPMV");
	services[nbServices++] = new String ("CTPMV");
	services[nbServices++] = new String ("ZTPMV");
	services[nbServices++] = new String ("STRSV");
	services[nbServices++] = new String ("DTRSV");
	services[nbServices++] = new String ("CTRSV");
	services[nbServices++] = new String ("ZTRSV");
	services[nbServices++] = new String ("STBSV");
	services[nbServices++] = new String ("DTBSV");
	services[nbServices++] = new String ("CTBSV");
	services[nbServices++] = new String ("ZTBSV");
	services[nbServices++] = new String ("STPSV");
	services[nbServices++] = new String ("DTPSV");
	services[nbServices++] = new String ("CTPSV");
	services[nbServices++] = new String ("ZTPSV");
	services[nbServices++] = new String ("SGER");
	services[nbServices++] = new String ("DGER");
	services[nbServices++] = new String ("CGERU");
	services[nbServices++] = new String ("ZGERU");
	services[nbServices++] = new String ("CGERC");
	services[nbServices++] = new String ("ZGERC");
	services[nbServices++] = new String ("CHER");
	services[nbServices++] = new String ("ZHER");
	services[nbServices++] = new String ("CHPR");
	services[nbServices++] = new String ("ZHPR");
	services[nbServices++] = new String ("CHER2");
	services[nbServices++] = new String ("ZHER2");
	services[nbServices++] = new String ("CHPR2");
	services[nbServices++] = new String ("ZHPR2");
	services[nbServices++] = new String ("SSYR");
	services[nbServices++] = new String ("DSYR");
	services[nbServices++] = new String ("SSPR");
	services[nbServices++] = new String ("DSPR");
	services[nbServices++] = new String ("SSYR2");
	services[nbServices++] = new String ("DSYR2");
	services[nbServices++] = new String ("SSPR2");
	services[nbServices++] = new String ("DSPR2");

	services[nbServices++] = new String ("SGEMM");
	services[nbServices++] = new String ("DGEMM");
	services[nbServices++] = new String ("CGEMM");
	services[nbServices++] = new String ("ZGEMM");
	services[nbServices++] = new String ("SSYMM");
	services[nbServices++] = new String ("DSYMM");
	services[nbServices++] = new String ("CSYMM");
	services[nbServices++] = new String ("ZSYMM");
	services[nbServices++] = new String ("CHEMM");
	services[nbServices++] = new String ("ZHEMM");
	services[nbServices++] = new String ("SSYRK");
	services[nbServices++] = new String ("DSYRK");
	services[nbServices++] = new String ("CSYRK");
	services[nbServices++] = new String ("ZSYRK");
	services[nbServices++] = new String ("CHERK");
	services[nbServices++] = new String ("ZHERK");
	services[nbServices++] = new String ("SSYR2K");
	services[nbServices++] = new String ("DSYR2K");
	services[nbServices++] = new String ("CSYR2K");
	services[nbServices++] = new String ("ZSYR2K");
	services[nbServices++] = new String ("CHER2K");
	services[nbServices++] = new String ("ZHER2K");
	services[nbServices++] = new String ("STRMM");
	services[nbServices++] = new String ("DTRMM");
	services[nbServices++] = new String ("CTRMM");
	services[nbServices++] = new String ("ZTRMM");
	services[nbServices++] = new String ("STRSM");
	services[nbServices++] = new String ("DTRSM");
	services[nbServices++] = new String ("CTRSM");
	services[nbServices++] = new String ("ZTRSM");

	//************ PBLAS ***********

	services[nbServices++] = new String ("PSSWAP");
	services[nbServices++] = new String ("PDSWAP");
	services[nbServices++] = new String ("PCSWAP");
	services[nbServices++] = new String ("PZSWAP");	
	services[nbServices++] = new String ("PSSCAL");
	services[nbServices++] = new String ("PDSCAL");
	services[nbServices++] = new String ("PCSCAL");
	services[nbServices++] = new String ("PZSCAL");
	services[nbServices++] = new String ("PCSSCAL");
	services[nbServices++] = new String ("PZDSCAL");
	services[nbServices++] = new String ("PSCOPY");
	services[nbServices++] = new String ("PDCOPY");
	services[nbServices++] = new String ("PCCOPY");
	services[nbServices++] = new String ("PZCOPY");
	services[nbServices++] = new String ("PSAXPY");
	services[nbServices++] = new String ("PDAXPY");
	services[nbServices++] = new String ("PCAXPY");
	services[nbServices++] = new String ("PZAXPY");	
	services[nbServices++] = new String ("PSDOT");
	services[nbServices++] = new String ("PDDOT");
	services[nbServices++] = new String ("PDSDOT");
	services[nbServices++] = new String ("PCDOTU");	
	services[nbServices++] = new String ("PZDOTU");
	services[nbServices++] = new String ("PCDOTC");
	services[nbServices++] = new String ("PZDOTC");
	services[nbServices++] = new String ("PSNRM2");	
	services[nbServices++] = new String ("PDRRM2");
	services[nbServices++] = new String ("PSCNRM2");
	services[nbServices++] = new String ("PDZNRM2");
	services[nbServices++] = new String ("PSASUM");	
	services[nbServices++] = new String ("PDASUM");
	services[nbServices++] = new String ("PSCASUM");
	services[nbServices++] = new String ("PDZASUM");
	services[nbServices++] = new String ("PSAMAX");
	services[nbServices++] = new String ("PDAMAX");
	services[nbServices++] = new String ("PCAMAX");
	services[nbServices++] = new String ("PAMAX");

	services[nbServices++] = new String ("PSGEMV");
	services[nbServices++] = new String ("PDGEMV");
	services[nbServices++] = new String ("PCGEMV");
	services[nbServices++] = new String ("PZGEMV");
	services[nbServices++] = new String ("PCHEMV");
	services[nbServices++] = new String ("PZHEMV");
	services[nbServices++] = new String ("PSSYMV");
	services[nbServices++] = new String ("PDSYMV");
	services[nbServices++] = new String ("PSSBMV");
	services[nbServices++] = new String ("PSTRMV");
	services[nbServices++] = new String ("PDTRMV");
	services[nbServices++] = new String ("PCTRMV");
	services[nbServices++] = new String ("PZTRMV");
	services[nbServices++] = new String ("PSTRSV");
	services[nbServices++] = new String ("PDTRSV");
	services[nbServices++] = new String ("PCTRSV");
	services[nbServices++] = new String ("PZTRSV");
	services[nbServices++] = new String ("PSGER");
	services[nbServices++] = new String ("PDGER");
	services[nbServices++] = new String ("PCGERU");
	services[nbServices++] = new String ("PZGERU");
	services[nbServices++] = new String ("PCGERC");
	services[nbServices++] = new String ("PZGERC");
	services[nbServices++] = new String ("PCHER");
	services[nbServices++] = new String ("PZHER");
	services[nbServices++] = new String ("PCHER2");
	services[nbServices++] = new String ("PZHER2");
	services[nbServices++] = new String ("PSSYR");
	services[nbServices++] = new String ("PDSYR");
	services[nbServices++] = new String ("PSSYR2");
	services[nbServices++] = new String ("PDSYR2");
	
	services[nbServices++] = new String ("PSGEMM");
	services[nbServices++] = new String ("PDGEMM");
	services[nbServices++] = new String ("PCGEMM");
	services[nbServices++] = new String ("PZGEMM");
	services[nbServices++] = new String ("PSSYMM");
	services[nbServices++] = new String ("PDSYMM");
	services[nbServices++] = new String ("PCSYMM");
	services[nbServices++] = new String ("PZSYMM");
	services[nbServices++] = new String ("PCHEMM");
	services[nbServices++] = new String ("PZHEMM");
	services[nbServices++] = new String ("PSSYRK");
	services[nbServices++] = new String ("PDSYRK");
	services[nbServices++] = new String ("PCSYRK");
	services[nbServices++] = new String ("PZSYRK");
	services[nbServices++] = new String ("PCHERK");
	services[nbServices++] = new String ("PZHERK");
	services[nbServices++] = new String ("PSSYR2K");
	services[nbServices++] = new String ("PDSYR2K");
	services[nbServices++] = new String ("PCSYR2K");
	services[nbServices++] = new String ("PZSYR2K");
	services[nbServices++] = new String ("PCHER2K");
	services[nbServices++] = new String ("PZHER2K");
	services[nbServices++] = new String ("PSTRMM");
	services[nbServices++] = new String ("PDTRMM");
	services[nbServices++] = new String ("PCTRMM");
	services[nbServices++] = new String ("PZTRMM");
	services[nbServices++] = new String ("PSTRSM");
	services[nbServices++] = new String ("PDTRSM");
	services[nbServices++] = new String ("PCTRSM");
	services[nbServices++] = new String ("PZTRSM");

	services[nbServices++] = new String ("PSTRAN");
	services[nbServices++] = new String ("PDTRAN");
	services[nbServices++] = new String ("PCTRANU");
	services[nbServices++] = new String ("PZTRANU");
	services[nbServices++] = new String ("PCTRANC");
	services[nbServices++] = new String ("PZTRANC");
    
	/************ LAPACK ***********/
	services[nbServices++] = new String("SBDSDC");
	services[nbServices++] = new String("SBDSQR");
	services[nbServices++] = new String("CBDSQR");
	services[nbServices++] = new String("SDISNA");
	services[nbServices++] = new String("SGBBRD");
	services[nbServices++] = new String("CGBBRD");
	services[nbServices++] = new String("SGBCON");
	services[nbServices++] = new String("CGBCON");
	services[nbServices++] = new String("SGBEQU");
	services[nbServices++] = new String("CGBEQU");
	services[nbServices++] = new String("SGBRFS");
	services[nbServices++] = new String("CGBRFS");
	services[nbServices++] = new String("SGBSV");
	services[nbServices++] = new String("CGBSV");
	services[nbServices++] = new String("SGBSVX");
	services[nbServices++] = new String("CGBSVX");
	services[nbServices++] = new String("SGBTRF");
	services[nbServices++] = new String("CGBTRF");
	services[nbServices++] = new String("SGBTRS");
	services[nbServices++] = new String("CGBTRS");
	services[nbServices++] = new String("SGEBAK");
	services[nbServices++] = new String("CGEBAK");
	services[nbServices++] = new String("SGEBAL");
	services[nbServices++] = new String("CGEBAL");
	services[nbServices++] = new String("SGEBRD");
	services[nbServices++] = new String("CGEBRD");
	services[nbServices++] = new String("SGECON");
	services[nbServices++] = new String("CGECON");
	services[nbServices++] = new String("SGEEQU");
	services[nbServices++] = new String("CGEEQU");
	services[nbServices++] = new String("SGEESX");
	services[nbServices++] = new String("CGEESX");
	services[nbServices++] = new String("SGEEV");
	services[nbServices++] = new String("CGEEV");
	services[nbServices++] = new String("SGEEVX");
	services[nbServices++] = new String("CGEEVX");
	services[nbServices++] = new String("SGEHRD");
	services[nbServices++] = new String("CGEHRD");
	services[nbServices++] = new String("SGELQF");
	services[nbServices++] = new String("CGELQF");
	services[nbServices++] = new String("SGELS");
	services[nbServices++] = new String("CGELS");
	services[nbServices++] = new String("SGELSD");
	services[nbServices++] = new String("CGELSD");
	services[nbServices++] = new String("SGELSS");
	services[nbServices++] = new String("CGELSS");
	services[nbServices++] = new String("SGELSY");
	services[nbServices++] = new String("CGELSY");
	services[nbServices++] = new String("SGEQLF");
	services[nbServices++] = new String("CGEQLF");
	services[nbServices++] = new String("SGEQP3");
	services[nbServices++] = new String("CGEQP3");
	services[nbServices++] = new String("SGEQRF");
	services[nbServices++] = new String("CGEQRF");
	services[nbServices++] = new String("SGERFS");
	services[nbServices++] = new String("CGERFS");
	services[nbServices++] = new String("SGERQF");
	services[nbServices++] = new String("CGERQF");
	services[nbServices++] = new String("SGESDD");
	services[nbServices++] = new String("CGESDD");
	services[nbServices++] = new String("SGESV");
	services[nbServices++] = new String("CGESV");
	services[nbServices++] = new String("SGESVD");
	services[nbServices++] = new String("CGESVD");
	services[nbServices++] = new String("SGESVX");
	services[nbServices++] = new String("CGESVX");
	services[nbServices++] = new String("SGETRF");
	services[nbServices++] = new String("CGETRF");
	services[nbServices++] = new String("SGETRI");	
	services[nbServices++] = new String("CGETRI");
	services[nbServices++] = new String("SGETRS");
	services[nbServices++] = new String("CGETRS"); 
	services[nbServices++] = new String("SGGBAK"); 	
	services[nbServices++] = new String("CGGBAK"); 
	services[nbServices++] = new String("SGGBAL");
	services[nbServices++] = new String("CGGBAL");
	services[nbServices++] = new String("SGGES"); 		 
	services[nbServices++] = new String("CGGES"); 
	services[nbServices++] = new String("SGGESX"); 		 
	services[nbServices++] = new String("CGGESX");
	services[nbServices++] = new String("SGGEV"); 		 
	services[nbServices++] = new String("CGGEV");
	services[nbServices++] = new String("SGGEVX");	 
	services[nbServices++] = new String("CGGEVX"); 
	services[nbServices++] = new String("SGGGLM"); 		 
	services[nbServices++] = new String("CGGGLM"); 
	services[nbServices++] = new String("SGGHRD"); 		 
	services[nbServices++] = new String("CGGHRD"); 
	services[nbServices++] = new String("SGGLSE"); 		 
	services[nbServices++] = new String("CGGLSE"); 	
	services[nbServices++] = new String("SGGQRF"); 		 
	services[nbServices++] = new String("CGGQRF"); 	
	services[nbServices++] = new String("SGGRQF"); 		 
	services[nbServices++] = new String("CGGRQF"); 
	services[nbServices++] = new String("SGGSVD"); 		 
	services[nbServices++] = new String("CGGSVD"); 	
	services[nbServices++] = new String("SGGSVP"); 		 
	services[nbServices++] = new String("CGGSVP"); 
	services[nbServices++] = new String("SGTCON"); 		 
	services[nbServices++] = new String("CGTCON"); 
	services[nbServices++] = new String("SGTRFS"); 		 
	services[nbServices++] = new String("CGTRFS"); 	
	services[nbServices++] = new String("SGTSV"); 		 
	services[nbServices++] = new String("CGTSV");
	services[nbServices++] = new String("SGTSVX"); 		 
	services[nbServices++] = new String("CGTSVX"); 
	services[nbServices++] = new String("SGTTRF"); 		 
	services[nbServices++] = new String("CGTTRF"); 
	services[nbServices++] = new String("SGTTRS"); 		 
	services[nbServices++] = new String("CGTTRS"); 
	services[nbServices++] = new String("SHGEQZ"); 		 
	services[nbServices++] = new String("CHGEQZ"); 
	services[nbServices++] = new String("SHSEIN"); 		 
	services[nbServices++] = new String("CHSEIN");
	services[nbServices++] = new String("SHSEQR"); 		 
	services[nbServices++] = new String("CHSEQR"); 
	services[nbServices++] = new String("SOPGTR"); 		 
	services[nbServices++] = new String("CUPGTR"); 
	services[nbServices++] = new String("SOPMTR"); 		 
	services[nbServices++] = new String("CUPMTR"); 
	services[nbServices++] = new String("SORGBR"); 		 
	services[nbServices++] = new String("CUNGBR"); 
	services[nbServices++] = new String("SORGHR"); 		 
	services[nbServices++] = new String("CUNGHR"); 
	services[nbServices++] = new String("SORGLQ"); 		 
	services[nbServices++] = new String("CUNGLQ"); 
	services[nbServices++] = new String("SORGQL"); 		 
	services[nbServices++] = new String("CUNGQL");
	services[nbServices++] = new String("SORGQR"); 		 
	services[nbServices++] = new String("CUNGQR"); 
	services[nbServices++] = new String("SORGRQ"); 		 
	services[nbServices++] = new String("CUNGRQ"); 
	services[nbServices++] = new String("SORGTR"); 		 
	services[nbServices++] = new String("CUNGTR"); 	
	services[nbServices++] = new String("SORMBR"); 		 
	services[nbServices++] = new String("CUNMBR"); 	
	services[nbServices++] = new String("SORMHR"); 		 
	services[nbServices++] = new String("CUNMHR"); 	
	services[nbServices++] = new String("SORMLQ"); 		 
	services[nbServices++] = new String("CUNMLQ"); 
	services[nbServices++] = new String("SORMQL"); 		 
	services[nbServices++] = new String("CUNMQL");
	services[nbServices++] = new String("SORMQR"); 		 
	services[nbServices++] = new String("CUNMQR"); 	
	services[nbServices++] = new String("SORMRQ"); 		 
	services[nbServices++] = new String("CUNMRQ"); 
	services[nbServices++] = new String("SORMRZ"); 		 
	services[nbServices++] = new String("CUNMRZ");
	services[nbServices++] = new String("SORMTR"); 		 
	services[nbServices++] = new String("CUNMTR"); 
	services[nbServices++] = new String("SPBCON"); 		 
	services[nbServices++] = new String("CPBCON");
	services[nbServices++] = new String("SPBEQU"); 		 
	services[nbServices++] = new String("CPBEQU");
	services[nbServices++] = new String("SPBRFS"); 		 
	services[nbServices++] = new String("CPBRFS");
	services[nbServices++] = new String("SPBSTF"); 		 
	services[nbServices++] = new String("CPBSTF");
	services[nbServices++] = new String("SPBSV"); 		 	 
	services[nbServices++] = new String("CPBSV");
	services[nbServices++] = new String("SPBSVX"); 		 
	services[nbServices++] = new String("CPBSVX"); 
	services[nbServices++] = new String("SPBTRF"); 		 
	services[nbServices++] = new String("SPBTRS"); 		 
	services[nbServices++] = new String("CPBTRS");
	services[nbServices++] = new String("SPOCON"); 		 
	services[nbServices++] = new String("CPOCON");
	services[nbServices++] = new String("SPOEQU"); 		 
	services[nbServices++] = new String("CPOEQU");
	services[nbServices++] = new String("SPORFS");	 
	services[nbServices++] = new String("CPORFS"); 	
	services[nbServices++] = new String("SPOSV"); 		 
	services[nbServices++] = new String("CPOSV"); 
	services[nbServices++] = new String("SPOSVX"); 		 
	services[nbServices++] = new String("CPOSVX"); 	
	services[nbServices++] = new String("SPOTRF");		 
	services[nbServices++] = new String("CPOTRF");	
	services[nbServices++] = new String("SPOTRI"); 		 
	services[nbServices++] = new String("CPOTRI"); 	
	services[nbServices++] = new String("SPOTRS"); 		 
	services[nbServices++] = new String("CPOTRS"); 	
	services[nbServices++] = new String("SPPCON"); 		 
	services[nbServices++] = new String("CPPCON"); 
	services[nbServices++] = new String("SPPEQU"); 		 
	services[nbServices++] = new String("CPPEQU"); 
	services[nbServices++] = new String("SPPRFS"); 		 
	services[nbServices++] = new String("CPPRFS"); 
	services[nbServices++] = new String("SPPSV"); 		 
	services[nbServices++] = new String("CPPSV");	
	services[nbServices++] = new String("SPPSVX"); 		 
	services[nbServices++] = new String("CPPSVX"); 	
	services[nbServices++] = new String("SPPTRF"); 		 
	services[nbServices++] = new String("CPPTRF"); 	
	services[nbServices++] = new String("SPPTRI"); 		 
	services[nbServices++] = new String("CPPTRI"); 	
	services[nbServices++] = new String("SPPTRS"); 		 
	services[nbServices++] = new String("CPPTRS"); 	
	services[nbServices++] = new String("SPTCON"); 		 
	services[nbServices++] = new String("CPTCON"); 	
	services[nbServices++] = new String("SPTEQR"); 		 
	services[nbServices++] = new String("CPTEQR"); 
	services[nbServices++] = new String("SPTRFS"); 		 
	services[nbServices++] = new String("CPTRFS"); 	
	services[nbServices++] = new String("SPTSV"); 		 
	services[nbServices++] = new String("CPTSV"); 	
	services[nbServices++] = new String("SPTSVX"); 		 
	services[nbServices++] = new String("CPTSVX"); 	
	services[nbServices++] = new String("SPTTRF"); 		 
	services[nbServices++] = new String("CPTTRF"); 	
	services[nbServices++] = new String("SPTTRS"); 		 
	services[nbServices++] = new String("CPTTRS"); 	
	services[nbServices++] = new String("SSBEV"); 		 
	services[nbServices++] = new String("CHBEV"); 	
	services[nbServices++] = new String("SSBEVD"); 		 
	services[nbServices++] = new String("CHBEVD"); 	
	services[nbServices++] = new String("SSBEVX"); 		 
	services[nbServices++] = new String("CHBEVX"); 	
	services[nbServices++] = new String("SSBGST"); 		 
	services[nbServices++] = new String("CHBGST"); 	
	services[nbServices++] = new String("SSBGV"); 		 
	services[nbServices++] = new String("CHBGV"); 	
	services[nbServices++] = new String("SSBGVD"); 		 
	services[nbServices++] = new String("CHBGVD"); 	
	services[nbServices++] = new String("SSBGVX"); 		 
	services[nbServices++] = new String("CHBGVX"); 	
	services[nbServices++] = new String("SSBTRD"); 		 
	services[nbServices++] = new String("CHBTRD"); 	
	services[nbServices++] = new String("SSPCON"); 		 
	services[nbServices++] = new String("CSPCON");
	services[nbServices++] = new String("CHPCON"); 
	services[nbServices++] = new String("SSPEV"); 		 
	services[nbServices++] = new String("CHPEV"); 	
	services[nbServices++] = new String("SSPEVD"); 		 
	services[nbServices++] = new String("CHPEVD"); 	
	services[nbServices++] = new String("SSPEVX"); 		 
	services[nbServices++] = new String("CHPEVX");
	services[nbServices++] = new String("SSPGST"); 		 
	services[nbServices++] = new String("CHPGST"); 
	services[nbServices++] = new String("SSPGV"); 		 
	services[nbServices++] = new String("CHPGV"); 	
	services[nbServices++] = new String("SSPGVD"); 		 
	services[nbServices++] = new String("CHPGVD"); 	
	services[nbServices++] = new String("SSPGVX"); 		 
	services[nbServices++] = new String("CHPGVX"); 	
	services[nbServices++] = new String("SSPRFS"); 		 
	services[nbServices++] = new String("CSPRFS"); 	 
	services[nbServices++] = new String("CHPRFS"); 	
	services[nbServices++] = new String("SSPSV"); 		 
	services[nbServices++] = new String("CSPSV"); 	 
	services[nbServices++] = new String("CHPSV"); 	
	services[nbServices++] = new String("SSPSVX"); 		 
	services[nbServices++] = new String("CSPSVX"); 	 
	services[nbServices++] = new String("CHPSVX"); 	
	services[nbServices++] = new String("SSPTRD"); 		 
	services[nbServices++] = new String("CHPTRD");
	services[nbServices++] = new String("SSPTRF"); 		 
	services[nbServices++] = new String("CSPTRF"); 	 
	services[nbServices++] = new String("CHPTRF"); 	
	services[nbServices++] = new String("SSPTRI"); 		 
	services[nbServices++] = new String("CSPTRI"); 	 
	services[nbServices++] = new String("CHPTRI"); 	
	services[nbServices++] = new String("SSPTRS"); 		 
	services[nbServices++] = new String("CSPTRS"); 	 
	services[nbServices++] = new String("CHPTRS"); 	
	services[nbServices++] = new String("SSTEBZ"); 	  	
	services[nbServices++] = new String("SSTEDC"); 		 
	services[nbServices++] = new String("CSTEDC"); 	
	services[nbServices++] = new String("SSTEGR"); 		 
	services[nbServices++] = new String("CSTEGR"); 	
	services[nbServices++] = new String("SSTEIN"); 		 
	services[nbServices++] = new String("CSTEIN"); 	
	services[nbServices++] = new String("SSTEQR"); 		 
	services[nbServices++] = new String("CSTEQR"); 	
	services[nbServices++] = new String("SSTERF"); 	  	
	services[nbServices++] = new String("SSTEV"); 	  	
	services[nbServices++] = new String("SSTEVD"); 	  	
	services[nbServices++] = new String("SSTEVR"); 	  	
	services[nbServices++] = new String("SSTEVX"); 	  	
	services[nbServices++] = new String("SSYCON"); 		 
	services[nbServices++] = new String("CSYCON"); 	 
	services[nbServices++] = new String("CHECON"); 	
	services[nbServices++] = new String("SSYEV"); 		 
	services[nbServices++] = new String("CHEEV"); 	
	services[nbServices++] = new String("SSYEVD"); 		 
	services[nbServices++] = new String("CHEEVD"); 	
	services[nbServices++] = new String("SSYEVR"); 		 
	services[nbServices++] = new String("CHEEVR"); 	
	services[nbServices++] = new String("SSYEVX"); 		 
	services[nbServices++] = new String("CHEEVX"); 	
	services[nbServices++] = new String("SSYGST"); 		 
	services[nbServices++] = new String("CHEGST"); 	
	services[nbServices++] = new String("SSYGV");		 
	services[nbServices++] = new String("CHEGV"); 	
	services[nbServices++] = new String("SSYGVD"); 		 
	services[nbServices++] = new String("CHEGVD"); 	
	services[nbServices++] = new String("SSYGVX"); 		 
	services[nbServices++] = new String("CHEGVX"); 	
	services[nbServices++] = new String("SSYRFS"); 		 
	services[nbServices++] = new String("CSYRFS"); 	 
	services[nbServices++] = new String("CHERFS"); 	
	services[nbServices++] = new String("SSYSV"); 		 
	services[nbServices++] = new String("CSYSV"); 	 
	services[nbServices++] = new String("CHESV"); 	
	services[nbServices++] = new String("SSYSVX"); 		 
	services[nbServices++] = new String("CSYSVX");	 
	services[nbServices++] = new String("CHESVX"); 	
	services[nbServices++] = new String("SSYTRD"); 		 
	services[nbServices++] = new String("CHETRD"); 	
	services[nbServices++] = new String("SSYTRF"); 		 
	services[nbServices++] = new String("CSYTRF"); 	 
	services[nbServices++] = new String("CHETRF"); 	
	services[nbServices++] = new String("SSYTRI"); 		 
	services[nbServices++] = new String("CSYTRI"); 	 
	services[nbServices++] = new String("CHETRI"); 	
	services[nbServices++] = new String("SSYTRS"); 		 
	services[nbServices++] = new String("CSYTRS"); 	 
	services[nbServices++] = new String("CHETRS"); 	
	services[nbServices++] = new String("STBCON"); 		 
	services[nbServices++] = new String("CTBCON"); 	
	services[nbServices++] = new String("STBRFS"); 	 
	services[nbServices++] = new String("CTBRFS"); 	
	services[nbServices++] = new String("STBTRS"); 		 
	services[nbServices++] = new String("CTBTRS"); 	
	services[nbServices++] = new String("STGEVC"); 		 
	services[nbServices++] = new String("CTGEVC"); 	
	services[nbServices++] = new String("STGEXC"); 		 
	services[nbServices++] = new String("CTGEXC"); 	
	services[nbServices++] = new String("STGSEN"); 		 
	services[nbServices++] = new String("CTGSEN"); 	
	services[nbServices++] = new String("STGSJA"); 		 
	services[nbServices++] = new String("CTGSJA"); 	
	services[nbServices++] = new String("STGSNA"); 		 
	services[nbServices++] = new String("CTGSNA"); 	
	services[nbServices++] = new String("STGSYL"); 		 
	services[nbServices++] = new String("CTGSYL"); 	
	services[nbServices++] = new String("STPCON"); 		 
	services[nbServices++] = new String("CTPCON"); 	
	services[nbServices++] = new String("STPRFS"); 		 
	services[nbServices++] = new String("CTPRFS"); 	
	services[nbServices++] = new String("STPTRI"); 		 
	services[nbServices++] = new String("CTPTRI"); 	
	services[nbServices++] = new String("STPTRS"); 		 
	services[nbServices++] = new String("CTPTRS"); 	
	services[nbServices++] = new String("STRCON"); 		 
	services[nbServices++] = new String("CTRCON"); 	
	services[nbServices++] = new String("STREVC"); 		 
	services[nbServices++] = new String("CTREVC"); 	
	services[nbServices++] = new String("STREXC"); 		 
	services[nbServices++] = new String("CTREXC"); 	
	services[nbServices++] = new String("STRRFS"); 		 
	services[nbServices++] = new String("CTRRFS");
	services[nbServices++] = new String("STRSEN"); 		 
	services[nbServices++] = new String("CTRSEN"); 
	services[nbServices++] = new String("STRSNA"); 		 
	services[nbServices++] = new String("CTRSNA"); 
	services[nbServices++] = new String("STRSYL");		 
	services[nbServices++] = new String("CTRSYL"); 
	services[nbServices++] = new String("STRTRI"); 		 
	services[nbServices++] = new String("CTRTRI"); 
	services[nbServices++] = new String("STRTRS"); 		 
	services[nbServices++] = new String("CTRTRS"); 
	services[nbServices++] = new String("STZRZF"); 		 
	services[nbServices++] = new String("CTZRZF");
    
	//************** ScaLAPACK  *************

	services[nbServices++] = new String("PSGESV");
	services[nbServices++] = new String("PCGESV");
	services[nbServices++] = new String("PSDBSV");
	services[nbServices++] = new String("PSGBSV");
	services[nbServices++] = new String("PCGBSV");
	services[nbServices++] = new String("PSDTSV");
	services[nbServices++] = new String("PCDTSV");
	services[nbServices++] = new String("PSPOSV");
	services[nbServices++] = new String("PCPOSV");
	services[nbServices++] = new String("PSPBSV");
	services[nbServices++] = new String("PSPTSV");
	services[nbServices++] = new String("PCPTSV");

	services[nbServices++] = new String("PSGELS");
	services[nbServices++] = new String("PCGELS");
	services[nbServices++] = new String("PSSYEV");
	services[nbServices++] = new String("PSGESVD");

	services[nbServices++] = new String("PSGESVX");
	services[nbServices++] = new String("PCGESVX");
	services[nbServices++] = new String("PSPOSVX");
	services[nbServices++] = new String("PCPOSVX");

	services[nbServices++] = new String("PSSYEVX");
	services[nbServices++] = new String("PCHEEVX");
	services[nbServices++] = new String("PSSYGVX");
	services[nbServices++] = new String("PCHEGVX");	

/*
	int nbMachines = 0;
	String machines [] = new String [5000];
	int cpt;

	// FR
	// IMAG
	machines [nbMachines++] = new String("fr.imag.ita");

	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("fr.imag.ita0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 100; cpt++)
	    machines [nbMachines++] = new String("fr.imag.ita" + Integer.toString(cpt));

	// IRISA

	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("fr.irisa.paraci0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 65; cpt++)
	    machines [nbMachines++] = new String("fr.irisa.paraci" + Integer.toString(cpt));

	// ENS LYON

	for (cpt = 1; cpt < 17; cpt++)
	    machines [nbMachines++] = new String("fr.ens-lyon.ls" + Integer.toString(cpt));

	// CRISTAL

	for (cpt = 1; cpt < 16; cpt++)
	    machines [nbMachines++] = new String("fr.rocq-inria.clus" + Integer.toString(cpt));

	// GRID 5000
	// LYON

	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("fr.grid5000.lyon.node0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 100; cpt++)
	    machines [nbMachines++] = new String("fr.grid5000.lyon.node" + Integer.toString(cpt));


	// GRID 5000
	// RENNES

	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("fr.grid5000.rennes.node0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 100; cpt++)
	    machines [nbMachines++] = new String("fr.grid5000.rennes.node" + Integer.toString(cpt));

	// GRID 5000
	// GRENOBLE

	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("fr.grid5000.grenoble.node0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 100; cpt++)
	    machines [nbMachines++] = new String("fr.grid5000.grenoble.node" + Integer.toString(cpt));

	// GRID 5000
	// PARIS

	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("fr.grid5000.paris.node0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 100; cpt++)
	    machines [nbMachines++] = new String("fr.grid5000.paris.node" + Integer.toString(cpt));

	// GRID 5000
	// SOPHIA

	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("fr.grid5000.sophia.node0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 100; cpt++)
	    machines [nbMachines++] = new String("fr.grid5000.sophia.node" + Integer.toString(cpt));

	// GRID 5000
	// BORDEAUX

	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("fr.grid5000.bordeaux.node0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 100; cpt++)
	    machines [nbMachines++] = new String("fr.grid5000.bordeaux.node" + Integer.toString(cpt));

	// GRID 5000
	// TOULOUSE

	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("fr.grid5000.toulouse.node0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 100; cpt++)
	    machines [nbMachines++] = new String("fr.grid5000.toulouse.node" + Integer.toString(cpt));

	// EDU
	// Columbia

	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("edu.columbia.supercluster.node0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 73; cpt++)
	    machines [nbMachines++] = new String("edu.columbia.supercluster.node" + Integer.toString(cpt));

	// EDU
	// UCSD

	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("edu.ucsd.megacluster.node0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 51; cpt++)
	    machines [nbMachines++] = new String("edu.ucsd.megacluster.node" + Integer.toString(cpt));

	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("edu.ucsd.gigacluster.node0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 51; cpt++)
	    machines [nbMachines++] = new String("edu.ucsd.gigacluster.node" + Integer.toString(cpt));

	// EDU
	// Princeton

	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("edu.princeton.wilescluster.node0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 100; cpt++)
	    machines [nbMachines++] = new String("edu.princeton.wilescluster.node" + Integer.toString(cpt));

	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("edu.princeton.kruskalcluster.node0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 100; cpt++)
	    machines [nbMachines++] = new String("edu.princeton.kruskalcluster.node" + Integer.toString(cpt));


	// IT
	// Venezia

	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("it.unive.nodo0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 65; cpt++)
	    machines [nbMachines++] = new String("it.unive.nodo" + Integer.toString(cpt));


	// DE
	// Dresden
	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("de.tu-dresden.node0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 65; cpt++)
	    machines [nbMachines++] = new String("de.tu-dresden.node" + Integer.toString(cpt));


	// JP

	for (cpt = 1; cpt < 10; cpt++)
	    machines [nbMachines++] = new String("jp.ac.u-tokio.node0" + Integer.toString(cpt));

	for (cpt = 10; cpt < 100; cpt++)
	    machines [nbMachines++] = new String("jp.ac.u-tokio.node" + Integer.toString(cpt));

	int nbIP = 2500;
	for (cpt = 0; cpt < nbIP; cpt++)
	    {
		Random rIP = new Random();
		int o1 = rIP.nextInt(255);
		int o2 = rIP.nextInt(255);
		int o3 = rIP.nextInt(255);
		int o4 = rIP.nextInt(255);
		machines[nbMachines++] = new String (Integer.toString(o1) 
						     + "." + Integer.toString(o2) 
						     + "." + Integer.toString(o3) 
						     + "." + Integer.toString(o4));
	    }
	*/
	// VERIF
	/*
	for (int verif = 0; verif < nbMachines; verif++)
	    System.out.println(machines[verif]);
	    */
	/*
	int nbSystemes = 0;
	String systemes [] = new String [200];
	systemes [nbSystemes++] = new String ("linux mandrake 5.1");
	systemes [nbSystemes++] = new String ("linux mandrake 5.2");
	systemes [nbSystemes++] = new String ("linux mandrake 5.3");
	systemes [nbSystemes++] = new String ("linux mandrake 6.0");
	systemes [nbSystemes++] = new String ("linux mandrake 6.1");
	systemes [nbSystemes++] = new String ("linux mandrake 7.1");
	systemes [nbSystemes++] = new String ("linux mandrake 7.2");
	systemes [nbSystemes++] = new String ("linux mandrake 8.0");
	systemes [nbSystemes++] = new String ("linux mandrake 8.1");
	systemes [nbSystemes++] = new String ("linux mandrake 8.2");
	systemes [nbSystemes++] = new String ("linux mandrake 9.0");
	systemes [nbSystemes++] = new String ("linux mandrake 9.1");
	systemes [nbSystemes++] = new String ("linux mandrake 10.0");

	systemes [nbSystemes++] = new String ("linux debian 0.1");
	systemes [nbSystemes++] = new String ("linux debian 0.91");
	systemes [nbSystemes++] = new String ("linux debian 1.1");
	systemes [nbSystemes++] = new String ("linux debian 1.2");
	systemes [nbSystemes++] = new String ("linux debian 1.3");
	systemes [nbSystemes++] = new String ("linux debian 2.0");
	systemes [nbSystemes++] = new String ("linux debian 2.1");
	systemes [nbSystemes++] = new String ("linux debian 2.2");
	systemes [nbSystemes++] = new String ("linux debian 3.0");

	systemes [nbSystemes++] = new String ("linux redhat 1.0");
	systemes [nbSystemes++] = new String ("linux redhat 2.0");
	systemes [nbSystemes++] = new String ("linux redhat 3.0");
	systemes [nbSystemes++] = new String ("linux redhat 4.0");
	systemes [nbSystemes++] = new String ("linux redhat 4.2");
	systemes [nbSystemes++] = new String ("linux redhat 5.0");
	systemes [nbSystemes++] = new String ("linux redhat 5.1");
	systemes [nbSystemes++] = new String ("linux redhat 7.1");
	systemes [nbSystemes++] = new String ("linux redhat 7.2");
	systemes [nbSystemes++] = new String ("linux redhat 7.3");
	systemes [nbSystemes++] = new String ("linux redhat 8.0");
	systemes [nbSystemes++] = new String ("linux redhat 9.0");

	systemes [nbSystemes++] = new String ("linux fedora");

	systemes [nbSystemes++] = new String ("linux slackware 1.0");
	systemes [nbSystemes++] = new String ("linux slackware 2.0");
	systemes [nbSystemes++] = new String ("linux slackware 2.1");
	systemes [nbSystemes++] = new String ("linux slackware 2.2");
	systemes [nbSystemes++] = new String ("linux slackware 2.3");
	systemes [nbSystemes++] = new String ("linux slackware 3.0");
	systemes [nbSystemes++] = new String ("linux slackware 3.1");
	systemes [nbSystemes++] = new String ("linux slackware 3.4");
	systemes [nbSystemes++] = new String ("linux slackware 3.5");
	systemes [nbSystemes++] = new String ("linux slackware 3.6");
	systemes [nbSystemes++] = new String ("linux slackware 3.9");
	systemes [nbSystemes++] = new String ("linux slackware 4.0");
	systemes [nbSystemes++] = new String ("linux slackware 7.0");
	systemes [nbSystemes++] = new String ("linux slackware 7.1");
	systemes [nbSystemes++] = new String ("linux slackware 8.0");
	systemes [nbSystemes++] = new String ("linux slackware 9.0");

	systemes [nbSystemes++] = new String ("linux turbolinux 1");
	systemes [nbSystemes++] = new String ("linux turbolinux 2");
	systemes [nbSystemes++] = new String ("linux turbolinux 3");
	systemes [nbSystemes++] = new String ("linux turbolinux 4");
	systemes [nbSystemes++] = new String ("linux turbolinux 4.2");
	systemes [nbSystemes++] = new String ("linux turbolinux 6");
	systemes [nbSystemes++] = new String ("linux turbolinux 7");
	systemes [nbSystemes++] = new String ("linux turbolinux 7S");
	systemes [nbSystemes++] = new String ("linux turbolinux 8");
	systemes [nbSystemes++] = new String ("linux turbolinux 8S");

	systemes [nbSystemes++] = new String ("linux gentoo");
	systemes [nbSystemes++] = new String ("linux caldera");
	systemes [nbSystemes++] = new String ("linux corel");

	systemes [nbSystemes++] = new String ("linux red flag 1.0");
	systemes [nbSystemes++] = new String ("linux red flag 2.0");
	systemes [nbSystemes++] = new String ("linux red flag 3.0");
	systemes [nbSystemes++] = new String ("linux red flag 2.4");
	systemes [nbSystemes++] = new String ("linux red flag 3.2");

	systemes [nbSystemes++] = new String ("windows 95");
	systemes [nbSystemes++] = new String ("windows 98");
	systemes [nbSystemes++] = new String ("windows 98 SE");
	systemes [nbSystemes++] = new String ("windows NT");
	systemes [nbSystemes++] = new String ("windows XP");
	systemes [nbSystemes++] = new String ("windows 2000");
	systemes [nbSystemes++] = new String ("windows ME");

	systemes [nbSystemes++] = new String ("IBM OS2");
	systemes [nbSystemes++] = new String ("IBM OS2 WARP");
	systemes [nbSystemes++] = new String ("IBM OS2 WARP 4");

	systemes [nbSystemes++] = new String ("IBM AIX 1");
	systemes [nbSystemes++] = new String ("IBM AIX 2");
	systemes [nbSystemes++] = new String ("IBM AIX 3");
	systemes [nbSystemes++] = new String ("IBM AIX 3.1");
	systemes [nbSystemes++] = new String ("IBM AIX 3.2.5");
	systemes [nbSystemes++] = new String ("IBM AIX 4");
	systemes [nbSystemes++] = new String ("IBM AIX 4.1");
	systemes [nbSystemes++] = new String ("IBM AIX 4.1.1");
	systemes [nbSystemes++] = new String ("IBM AIX 4.1.2");
	systemes [nbSystemes++] = new String ("IBM AIX 4.1.3");
	systemes [nbSystemes++] = new String ("IBM AIX 4.1.4");
	systemes [nbSystemes++] = new String ("IBM AIX 4.1.5");
	systemes [nbSystemes++] = new String ("IBM AIX 4.2");
	systemes [nbSystemes++] = new String ("IBM AIX 4.3");
	systemes [nbSystemes++] = new String ("IBM AIX 5L");
	systemes [nbSystemes++] = new String ("IBM AIX 5L 5.2");

	systemes [nbSystemes++] = new String ("BSD 1");
	systemes [nbSystemes++] = new String ("BSD 2");
	systemes [nbSystemes++] = new String ("BSD 2.79");
	systemes [nbSystemes++] = new String ("BSD 2.8");
	systemes [nbSystemes++] = new String ("BSD 2.8.1");
	systemes [nbSystemes++] = new String ("BSD 2.8.2");
	systemes [nbSystemes++] = new String ("BSD 2.9");
	systemes [nbSystemes++] = new String ("BSD 2.9.1");
	systemes [nbSystemes++] = new String ("BSD 2.10");
	systemes [nbSystemes++] = new String ("BSD 2.10.1");
	systemes [nbSystemes++] = new String ("BSD 2.11");

	systemes [nbSystemes++] = new String ("Darwin 1.0");
	systemes [nbSystemes++] = new String ("Darwin 1.2.1");
	systemes [nbSystemes++] = new String ("Darwin 1.3.1");
	systemes [nbSystemes++] = new String ("Darwin 1.4.1");
	systemes [nbSystemes++] = new String ("Darwin 6.0.1");
	systemes [nbSystemes++] = new String ("Darwin 6.5");
	systemes [nbSystemes++] = new String ("Darwin 7.0");
	systemes [nbSystemes++] = new String ("Opendarwin");

	systemes [nbSystemes++] = new String ("MAC OS 1.0");
	systemes [nbSystemes++] = new String ("MAC OS 2.0");
	systemes [nbSystemes++] = new String ("MAC OS 3.0");
	systemes [nbSystemes++] = new String ("MAC OS 4.0");
	systemes [nbSystemes++] = new String ("MAC OS 4.1");
	systemes [nbSystemes++] = new String ("MAC OS 4.2");
	systemes [nbSystemes++] = new String ("MAC OS 6");
	systemes [nbSystemes++] = new String ("MAC OS 8.1");
	systemes [nbSystemes++] = new String ("MAC OS 8.5.1");
	systemes [nbSystemes++] = new String ("MAC OS 8.6");
	systemes [nbSystemes++] = new String ("MAC OS 9");
	systemes [nbSystemes++] = new String ("MAC OS X 1.0.2");
	systemes [nbSystemes++] = new String ("MAC OS X 1.2.3");
	systemes [nbSystemes++] = new String ("MAC OS X 10.1");
	systemes [nbSystemes++] = new String ("MAC OS X 10.2");

	systemes [nbSystemes++] = new String ("MS-DOS");

	systemes [nbSystemes++] = new String ("JavaOS 1.0");
	systemes [nbSystemes++] = new String ("JavaOS 2.1");
	systemes [nbSystemes++] = new String ("JavaOS 3.0");

	systemes [nbSystemes++] = new String ("AmigaOS");
	systemes [nbSystemes++] = new String ("PegasOS");
	systemes [nbSystemes++] = new String ("MorphOS");

	systemes [nbSystemes++] = new String ("Be OS");

	systemes [nbSystemes++] = new String ("Netware 5.0");
	systemes [nbSystemes++] = new String ("Netware 5.1");
	systemes [nbSystemes++] = new String ("Netware 6.0");
	systemes [nbSystemes++] = new String ("Netware 6.5");

	systemes [nbSystemes++] = new String ("HP-UX 1");
	systemes [nbSystemes++] = new String ("HP-UX 2");
	systemes [nbSystemes++] = new String ("HP-UX 3");
	systemes [nbSystemes++] = new String ("HP-UX 7");
	systemes [nbSystemes++] = new String ("HP-UX 8");
	systemes [nbSystemes++] = new String ("HP-UX 9.0.4");
	systemes [nbSystemes++] = new String ("HP-UX 10.01");
	systemes [nbSystemes++] = new String ("HP-UX 10.10");
	systemes [nbSystemes++] = new String ("HP-UX 10.20");
	systemes [nbSystemes++] = new String ("HP-UX 11.11");
	systemes [nbSystemes++] = new String ("HP-UX 11.20");

	systemes [nbSystemes++] = new String ("VMS 0.5");
	systemes [nbSystemes++] = new String ("VMS 1.0");
	systemes [nbSystemes++] = new String ("VMS 2.0");
	systemes [nbSystemes++] = new String ("VMS 2.2");
	systemes [nbSystemes++] = new String ("VMS 3.0");
	systemes [nbSystemes++] = new String ("VMS 4.0");
	systemes [nbSystemes++] = new String ("VMS 5.0");
	systemes [nbSystemes++] = new String ("VMS 5.2");
	systemes [nbSystemes++] = new String ("VMS 5.4");
	systemes [nbSystemes++] = new String ("VMS 5.5");

	systemes [nbSystemes++] = new String ("OpenVMS 6.0");
	systemes [nbSystemes++] = new String ("OpenVMS 6.1");
	systemes [nbSystemes++] = new String ("OpenVMS 6.2");
	systemes [nbSystemes++] = new String ("OpenVMS 7.0");
	systemes [nbSystemes++] = new String ("OpenVMS 7.1");
	systemes [nbSystemes++] = new String ("OpenVMS 7.2");
	systemes [nbSystemes++] = new String ("OpenVMS 7.3");
	systemes [nbSystemes++] = new String ("OpenVMS 8.0");

	systemes [nbSystemes++] = new String ("Unix");
	systemes [nbSystemes++] = new String ("Dunix");
	systemes [nbSystemes++] = new String ("UnixWare");

	systemes [nbSystemes++] = new String ("irix");
	systemes [nbSystemes++] = new String ("Qnx");
	systemes [nbSystemes++] = new String ("OpenQnx");
	systemes [nbSystemes++] = new String ("Minix");
	systemes [nbSystemes++] = new String ("NewDeal");
	systemes [nbSystemes++] = new String ("NextStep");
	systemes [nbSystemes++] = new String ("Plan9");
	systemes [nbSystemes++] = new String ("RISC OS");

	systemes [nbSystemes++] = new String ("Solaris 1");
	systemes [nbSystemes++] = new String ("Solaris 2");
	systemes [nbSystemes++] = new String ("Solaris 3");
	systemes [nbSystemes++] = new String ("Solaris 4");
	systemes [nbSystemes++] = new String ("Solaris 5");
	systemes [nbSystemes++] = new String ("Solaris 6");
	systemes [nbSystemes++] = new String ("Solaris 7");
	systemes [nbSystemes++] = new String ("Solaris 8");
	*/

	/*
	int nbProcs = 0;
	String procs [] = new String [200];

	procs [nbProcs++] = new String ("Am2901");
	procs [nbProcs++] = new String ("Am2903");
	procs [nbProcs++] = new String ("Am2910");
	procs [nbProcs++] = new String ("Am29009");
	procs [nbProcs++] = new String ("AMD 29000"); 
	procs [nbProcs++] = new String ("AMD 29027 FPU"); 
	procs [nbProcs++] = new String ("AMD 29030"); 
	procs [nbProcs++] = new String ("AMD 29050"); 
	procs [nbProcs++] = new String ("AMD 292xx"); 
	procs [nbProcs++] = new String ("Am286"); 
	procs [nbProcs++] = new String ("Am386"); 
	procs [nbProcs++] = new String ("Am486"); 
	procs [nbProcs++] = new String ("Am586"); 
	procs [nbProcs++] = new String ("AMD K5"); 
	procs [nbProcs++] = new String ("AMD K6"); 
	procs [nbProcs++] = new String ("AMD K6-2"); 
	procs [nbProcs++] = new String ("AMD K6-III"); 
	procs [nbProcs++] = new String ("AMD K6-III-P"); 
	procs [nbProcs++] = new String ("AMD K6-2+");
	procs [nbProcs++] = new String ("AMD K6-III+");
	procs [nbProcs++] = new String ("Athlon Slot A");
	procs [nbProcs++] = new String ("Athlon Socket A");
	procs [nbProcs++] = new String ("Duron");
	procs [nbProcs++] = new String ("Athlon MP");
	procs [nbProcs++] = new String ("Athon 4");
	procs [nbProcs++] = new String ("Athlon XP");
	procs [nbProcs++] = new String ("Mobile Athlon XP");
	procs [nbProcs++] = new String ("Mobile Duron");
	procs [nbProcs++] = new String ("Sempron");
	procs [nbProcs++] = new String ("Opteron");
	procs [nbProcs++] = new String ("Athlon 64 FX");
	procs [nbProcs++] = new String ("Athlon 64");
	procs [nbProcs++] = new String ("Mobile Athlon 64");
	procs [nbProcs++] = new String ("Athlon XP-M");
	procs [nbProcs++] = new String ("Sempron");
	procs [nbProcs++] = new String ("AMD K9");
	procs [nbProcs++] = new String ("AMD K10");

 	procs [nbProcs++] = new String ("Intel 4004");
	procs [nbProcs++] = new String ("Intel 4040");
 	procs [nbProcs++] = new String ("Intel 8008");
	procs [nbProcs++] = new String ("Intel 8080");
 	procs [nbProcs++] = new String ("Intel 8085");
	procs [nbProcs++] = new String ("Intel 8086");
 	procs [nbProcs++] = new String ("Intel 8088");
	procs [nbProcs++] = new String ("Intel 80186");
 	procs [nbProcs++] = new String ("Intel 80188");
	procs [nbProcs++] = new String ("Intel 80286");
 	procs [nbProcs++] = new String ("Intel iAPX 432");
	procs [nbProcs++] = new String ("Intel 80960");
 	procs [nbProcs++] = new String ("Intel 80860");
	procs [nbProcs++] = new String ("Intel 80386 DX");
 	procs [nbProcs++] = new String ("Intel 80386 SX");
	procs [nbProcs++] = new String ("Intel 80376");
 	procs [nbProcs++] = new String ("Intel 80386 SL");
	procs [nbProcs++] = new String ("Intel 386 EX");
 	procs [nbProcs++] = new String ("Intel 80486 DX");
	procs [nbProcs++] = new String ("Intel 80486 SX");
 	procs [nbProcs++] = new String ("Intel 80486 DX2");
	procs [nbProcs++] = new String ("Intel 80486 SL");
 	procs [nbProcs++] = new String ("Intel 80486 DX4");
 	procs [nbProcs++] = new String ("Intel Pentium");
 	procs [nbProcs++] = new String ("Intel Pentium Pro");
 	procs [nbProcs++] = new String ("Intel Pentium MMX");
 	procs [nbProcs++] = new String ("Intel Pentium II");
 	procs [nbProcs++] = new String ("Intel Pentium III");
 	procs [nbProcs++] = new String ("Intel Pentium II Xeon");
 	procs [nbProcs++] = new String ("Intel Pentium III Xeon");
 	procs [nbProcs++] = new String ("Intel Pentium M");
 	procs [nbProcs++] = new String ("Intel Pentium 4");
 	procs [nbProcs++] = new String ("Intel Xeon");
 	procs [nbProcs++] = new String ("Intel Pentium 4E");
 	procs [nbProcs++] = new String ("Intel Pentium 4EE");
 	procs [nbProcs++] = new String ("Intel Pentium 4F");
 	procs [nbProcs++] = new String ("Intel Itanium");
 	procs [nbProcs++] = new String ("Intel Itanium 2");
 	procs [nbProcs++] = new String ("Intel EM64T");

	procs [nbProcs++] = new String ("PowerPC 403");
	procs [nbProcs++] = new String ("PowerPC 405");
	procs [nbProcs++] = new String ("PowerPC 440");
	procs [nbProcs++] = new String ("PowerPC 601");
	procs [nbProcs++] = new String ("PowerPC 602");
	procs [nbProcs++] = new String ("PowerPC 603");
	procs [nbProcs++] = new String ("PowerPC 604");
	procs [nbProcs++] = new String ("PowerPC 620");
	procs [nbProcs++] = new String ("PowerPC GEKKO");
	procs [nbProcs++] = new String ("PowerPC G3");
	procs [nbProcs++] = new String ("PowerPC G4");
	procs [nbProcs++] = new String ("PowerPC G5");

	procs [nbProcs++] = new String ("DSP 60");
	procs [nbProcs++] = new String ("DSP 563");
	procs [nbProcs++] = new String ("DSP 566");
	procs [nbProcs++] = new String ("DSP 568");
	procs [nbProcs++] = new String ("DSP 96");

	procs [nbProcs++] = new String ("Motorola 6800");
	procs [nbProcs++] = new String ("Motorola 6809");
	procs [nbProcs++] = new String ("Motorola 68000");
	procs [nbProcs++] = new String ("Motorola 68008");
	procs [nbProcs++] = new String ("Motorola 68010");
	procs [nbProcs++] = new String ("Motorola 68012");
	procs [nbProcs++] = new String ("Motorola 68020");
	procs [nbProcs++] = new String ("Motorola 68030");
	procs [nbProcs++] = new String ("Motorola 68040");
	procs [nbProcs++] = new String ("Motorola 68060");
	procs [nbProcs++] = new String ("Motorola 88000");
	procs [nbProcs++] = new String ("Motorola Dragonball");
	procs [nbProcs++] = new String ("Motorola Coldfire");

	procs [nbProcs++] = new String ("DEC Alpha 21064");
	procs [nbProcs++] = new String ("DEC Alpha 21064A");
	procs [nbProcs++] = new String ("DEC Alpha 21066");
	procs [nbProcs++] = new String ("DEC Alpha 21066A");
	procs [nbProcs++] = new String ("DEC Alpha 21164");
	procs [nbProcs++] = new String ("DEC Alpha 21164A");
	procs [nbProcs++] = new String ("DEC Alpha 21164PC");
	procs [nbProcs++] = new String ("DEC Alpha 21264");
	procs [nbProcs++] = new String ("DEC Alpha 21264A");
	procs [nbProcs++] = new String ("DEC Alpha 21264B");
	procs [nbProcs++] = new String ("DEC Alpha 21264C");
	procs [nbProcs++] = new String ("DEC Alpha 21264D");
	procs [nbProcs++] = new String ("DEC Alpha 21364");

	procs [nbProcs++] = new String ("Efficeon TM 8800");
	procs [nbProcs++] = new String ("Efficeon TM 8620");
	procs [nbProcs++] = new String ("Efficeon TM 8600");

	procs [nbProcs++] = new String ("NEC V20");

	procs [nbProcs++] = new String ("Amiga Origninal Chipset");
	procs [nbProcs++] = new String ("Amiga Extended Chipset");
	
	procs [nbProcs++] = new String ("Zilog Z80");
	procs [nbProcs++] = new String ("Radio Shack TRS-80");
	procs [nbProcs++] = new String ("ZX Spectrum");
	*/

	// Flushing services into the objects vector
	objects = new String[nbServices];
	nbObjects = nbServices;
	for (int i = 0; i < nbServices; i++)
	    {
		objects[i] = services[i];
	    }

    } // Simulator
    
    /**
     * Maximize "locally" the throughput of logical nodes 
     * by distributing nodes handeled by peers indexed i and i - 1
     * before the redistribution.
     * @param i position of the peer to be possibly moved
     */
    private void stepLoadBalancing(int index)
    {
	// index of the successor
	int indexSucc;
	if (index == ring.getNbPeers() - 1)
	    indexSucc = 0;
	else
	    indexSucc = index + 1;
	
	// printing
// 	System.out.println ("Load balancing on peer " + index);
// 	System.out.println("ID of the first peer " + ring.peers[index].getID() +
// 			   ", capacity =  " + ring.peers[index].getCapacity());
// 	System.out.println("ID of the second peer " + 
// 			   ring.peers[indexSucc].getID()+ 
// 			   ", capacity =  " + ring.peers[indexSucc].getCapacity());
	
	// Concatenate the objects
		
	int nbNodes =  ring.peers[index].getNbNodes() + ring.peers[indexSucc].getNbNodes();
		
	if (nbNodes > 0)
	    {
		int [] nodes = new int [nbNodes];
		
		// Getting each one nodes
		int [] nodes1 = ring.peers[index].getNodes();
		int [] nodes2 = ring.peers[indexSucc].getNodes();
		
		// Concatenate
		for (int i = 0; i < ring.peers[index].getNbNodes(); i++) 
		    nodes[i] = nodes1[i];

		for (int i = 0; i < ring.peers[indexSucc].getNbNodes(); i++)
		    nodes[i + ring.peers[index].getNbNodes()] = nodes2[i];
			
		// find the best cut i_max with value max
		int max = 0;
		int i_max = 0;
		
		for (int i = 0; i <= nbNodes; i++)
		    {
			int load1 = 0;
			int load2 = 0;
			
			int j;
			for (j = 0; j < i; j++)
			    {
				load1 += tree.nodes[nodes[j]].getLoad();
			    }
			for (j = j; j < nbNodes; j++)
			    {
				load2 += tree.nodes[nodes[j]].getLoad();
			    }
				
			// System.out.println("If cut = " + i);
// 			System.out.println("\tThe load on the first peer is " + load1);
// 			System.out.println("\tThe load on the second peer is " + load2);
			
			int sat = Math.min (ring.peers[index].getCapacity(), load1) + 
			    Math.min (ring.peers[indexSucc].getCapacity(), load2);
				
			if (sat > max)
			    {
				max = Math.min (ring.peers[index].getCapacity(), load1) 
				    + Math.min (ring.peers[indexSucc].getCapacity(), load2);
				i_max = i;
			    }
			//			System.out.println("\tThe number of request satisfied is " + sat);
			
		    }

		// adapt the ID of the peer indexed by index
		if (i_max > 0)
		    ring.peers[index].setID(tree.nodes[nodes[i_max-1]].getID());
		else
		    {
			StringBuffer sb = new StringBuffer(tree.nodes[nodes[i_max]].getID());
			if (sb.length() != 0)
			    {	
				char c = sb.charAt(sb.length() - 1);
				sb.setCharAt(sb.length() - 1, (char)(c-1));
			    }
			
			for (int j = sb.length(); j < 50; j++)
			    sb.append("z");
			
			ring.peers[index].setID(sb.toString());
		    }

		// clear the mapping
		ring.peers[index].clearMapping();
		ring.peers[indexSucc].clearMapping();
			
		// redistribution
		// 1 : change the nodes on the peers
		// 2 : change the peer on the nodes
		int i;
		for (i = 0; i < i_max; i++)
		    {
			ring.peers[index].addNode(nodes[i], tree, ring);
			tree.nodes[nodes[i]].setPeer(index);		
		    }

		for (i = i; i < nbNodes; i++)
		    {
			ring.peers[indexSucc].addNode(nodes[i], tree, ring);
			tree.nodes[nodes[i]].setPeer(indexSucc);
		    }

// 		System.out.println("Result of the redistribution:");
// 		System.out.println("The peer labeled " + ring.peers[index].getID() + " manages " + 
// 				   ring.peers[index].getNbNodes() + " nodes:");

		// Nodes on the first peer
		int [] nodes1res = ring.peers[index].getNodes();
		
// 		for (int k = 0; k < ring.peers[index].getNbNodes(); k++)
// 		    {
// 			System.out.println("The node " + tree.nodes[nodes1res[k]].getID());
// 		    }

		// Nodes on the second peer
// 		System.out.println("The peer labeled " + ring.peers[indexSucc].getID() + " manages " + 
// 				   ring.peers[indexSucc].getNbNodes() + " nodes:");
		int [] nodes2res = ring.peers[indexSucc].getNodes();

// 		for (int k = 0; k < ring.peers[indexSucc].getNbNodes(); k++)
// 		    {
// 			System.out.println("The node " + tree.nodes[nodes2res[k]].getID());
// 		    }
	    }
	
    } //stepLoadBalancing
    
    /*
     * Insert a new peer into the ring with local load balancing
     * @param p peer to be inserted
     * @return -1 if not inserted, the index of p otherwise
     */

    private boolean insertLoadBalancing(Peer p)
    {
	System.out.println("Insertion of " + p.getID());
	if (ring.addPeerSorted(p, tree))
	    {
		System.out.println("Position: " + p.getIndex());
		stepLoadBalancing(p.getIndex());
		return(true);
	    }
	else
	    return(false);
		
    } // insertLoadBalancing

    /**
     * Compute the sum of the capacities of the peers
     */

    private boolean insertNoLoadBalancing(Peer p)
    {
	System.out.println("Insertion of " + p.getID());
	if (ring.addPeerSorted(p, tree))
	    {
		System.out.println("Position: " + p.getIndex());
		redistribute(p.getIndex());
		return(true);
	    }
	else
	    return(false);
	
    } // insertNoLoadBalancing
    
    /*
     * Redistributing nodes according to peer IDs
     * without any consideration of load balancing
     * @param index index and index + 1 redistribution
     */

    private void redistribute (int index)
    {

	int indexSucc;
	
	if (index == ring.getNbPeers() - 1)
	    indexSucc = 0;
	else
	    indexSucc = index + 1;
	
	String localID = ring.peers[index].getID();
	String succID = ring.peers[indexSucc].getID();

	int nbNodes = ring.peers[indexSucc].getNbNodes();
	
	int [] tmpNodes = ring.peers[indexSucc].getNodes();
	int [] nodes = new int [nbNodes];

	for (int i = 0; i < nbNodes; i++)
	    nodes[i] = tmpNodes[i];
	
	System.out.println("ID of successor: " + succID);
	
	System.out.println("Number of nodes to be redistributed: " + nbNodes + " : ");

	for (int i = 0; i < nbNodes; i++)
	    {
		System.out.println("Node " + nodes[i] + " " + tree.nodes[nodes[i]].getID());
	    }
	
	// redistribution of the nodes
	
	if (nbNodes > 0)
	    {	
		// clear the mapping
		ring.peers[index].clearMapping();
		ring.peers[indexSucc].clearMapping();

		if (localID.compareTo(succID) > 0)
		    // The local ID is greater than the ID of the successor
		    // The origin is between the two peers
		    {
			// searching the origin
			int i = 0;
			int origin = 0;
			
			while (i < nbNodes)
			    {
				if ((i > 0) && (tree.nodes[nodes[i-1]].getID().compareTo(tree.nodes[nodes[i]].getID()) > 0))
				    {
					origin = i;
					break;
				    }
				i++;
			    }
			int k = 0;

			// adding nodes
			while ((k < origin) && (tree.nodes[nodes[k]].getID().compareTo(ring.peers[index].getID()) < 0))
			    {
				ring.peers[index].addNode(nodes[k], tree, ring);
				tree.nodes[nodes[k]].setPeer(index);
				k++;
			    }

			for (; k < nbNodes; k++)
			    {
				ring.peers[indexSucc].addNode(nodes[k], tree, ring);
				tree.nodes[nodes[k]].setPeer(indexSucc);
			    }
			
		    }
		else if (tree.nodes[nodes[0]].getID().compareTo(succID) > 0)
		    // succ contains nodes before origin
		    // the new peer is the first after origin, replacing succ
		    {
			// finding the origin
			int i = 0;
			int origin = 0;
			
			while (i < nbNodes)
			    {
				if ((i > 0) && (tree.nodes[nodes[i-1]].getID().compareTo(tree.nodes[nodes[i]].getID()) > 0))
				    {
					origin = i;
					break;
				    }
				i++;
			    }
			int j = 0;
			
			// beginning by adding nodes before origin
			for (j = 0; j < origin; j++)
			    {	
				ring.peers[index].addNode(nodes[j], tree, ring);
				tree.nodes[nodes[j]].setPeer(index);
			    }
			
			
			// we reached the origin
			while ((j < nbNodes) &&
			       (tree.nodes[nodes[j]].getID().compareTo(localID)) < 0)
			    {
				ring.peers[index].addNode(nodes[j], tree, ring);
				tree.nodes[nodes[j]].setPeer(index);
				j++;   
			    }

			// the remaining on the successor
			while (j < nbNodes)
			    {
				ring.peers[indexSucc].addNode(nodes[j], tree, ring);
				tree.nodes[nodes[j]].setPeer(indexSucc);
				j++;   
			    }
		    }
		else // general case
		    {
			int j = 0;
			while ((j < nbNodes) &&
			       (tree.nodes[nodes[j]].getID().compareTo(localID)) < 0)
			    {
				ring.peers[index].addNode(nodes[j], tree, ring);
				tree.nodes[nodes[j]].setPeer(index);
				j++;
			    }
		
			// the remaining on the successor
			while (j < nbNodes)
			    {
				ring.peers[indexSucc].addNode(nodes[j], tree, ring);
				tree.nodes[nodes[j]].setPeer(indexSucc);
				j++;
			    }
		    }
	    }
	
	    
    } // redistribute
    
    private int computeRingCapacity()
    {
	int ringCapacity = 0;
	for (int i = 0; i < ring.getNbPeers(); i++)
	    {
		ringCapacity += ring.peers[i].getCapacity();
	    }
	return(ringCapacity);
	
    } //computeRingCapacity
    

    private int computeLoad(Peer p)
    {
	int load = 0;
	int nodes [] = p.getNodes();
	for (int i = 0; i < p.getNbNodes(); i++)
	    {
		load += tree.nodes[nodes[i]].getLoad();
	    }
	return(load);

    } // computeLoad
    
    private void mappingRand()     // Ranom mapping of the nodes on the peers
    {
	Random rand = new Random();
	
	for (int i = 0; i < tree.getNbNodes(); i++)
	    {
		if (tree.nodes[i].getPeer() == -1)
		    {
			int peer = rand.nextInt(100);
			tree.nodes[i].setPeer(peer);
			ring.peers[peer].addNode(i, tree, ring);
		    }
	    }
    } // mapping

    private void mappingAlpha() // alphabetic mapping of the nodes on the peers
    {
	for (int i = 0; i < tree.getNbNodes(); i++)
	    {
		int j = 0;
		while (ring.peers[j].getID().compareTo(tree.nodes[i].getID()) < 0)
		    {
			j++;
		    }

		ring.peers[j].addNode(i, tree, ring);
		tree.nodes[i].setPeer(j);
	    }
    } // mapping Alpha

    /**
     * one discrete simulation step
     * new peers (with load balancing)
     * new services
     * load balancing on random chosen peers
     * requests
     * computation of the number of request satisfied
     * @param void
     * @return void
     */
    private double simulationStepNoLB(int step)
    {
	// random Load Balancing (in average
	// each node balances every 3 steps)

// 	System.out.print("Random load balancing...");
// 	int nbPeers = ring.getNbPeers();
// 	Random rPeers = new Random();

// 	for (int i = 0; i < nbPeers/3; i++)
// 	    {
// 		stepLoadBalancing(rPeers.nextInt(nbPeers));
// 	    }
// 	System.out.println("done.");

	// inserting peers

	System.out.print("Inserting peers...");
	//	if (ring.getNbPeers() < 100)
	//	    {
		
		Random rID = new Random();
		Random rCapacity = new Random();
		
		int countInser = 0;
		while (countInser < 10) // to be tuned
		    {
			Peer p = new Peer((new RandomWord(50, rID)).getString());
			p.setCapacity(rCapacity.nextInt(81) + 20); // to be tuned
			
			if (insertNoLoadBalancing(p)) countInser++;
		    }
		//  }
	System.out.println("done.");

	// Removing peers

	System.out.println("Removing peers...");
	
	if (ring.getNbPeers() > 20)
	{
		Random rRemove = new Random();
		for (int i = 0; i < 10; i++)
		    {
			ring.removePeer(rRemove.nextInt(ring.getNbPeers()), tree, ring);
		    }
	}
	System.out.println("done.");
	
	// inserting objects

	System.out.print("Inserting objects...");

	for (int i = 0; i < nbObjects; i++)
	    {
		if (i % (int)(nbObjects/50) == step)
		    {
			RandomWord object = new RandomWord(objects[i]);
			
			if (!tree.present(object.getString()))
			    {
				int n = tree.inser(object, ring);
				insertedObjects[nbInsertedObjects++] = object.getString();
			    }
		    }
	    }
	
	System.out.println("done.");

	// checking the system

	System.out.println("Number of objects: " + tree.getNbNodes());

	for (int i = 0; i < tree.getNbNodes(); i++)
	    {
		System.out.print("Node" + i + " : " + tree.nodes[i].getID());
		System.out.print(" hosted by peer " + tree.nodes[i].getPeer() + " : ");
		System.out.println(ring.peers[tree.nodes[i].getPeer()].getID());
	    }
	
	for (int i = 0; i < ring.getNbPeers(); i++)
	    {
		System.out.println("Peer " + i + " : " + ring.peers[i].getID() + 
				   " with capacity " + ring.peers[i].getCapacity() +
			       " hosting :");
		int [] nodes = ring.peers[i].getNodes();
		for (int j = 0; j < ring.peers[i].getNbNodes(); j++)
		    {
			System.out.println(tree.nodes[nodes[j]].getID());
		    }
	    }

	    // reseting loads

	    System.out.print("Reseting peers' and nodes' load...");
	    ring.resetLoads();
	    tree.resetLoads();
	    System.out.println("done.");

	    // randomly requesting System.out.println("Requesting...");
	    
	    int nbRequests = (int)(computeRingCapacity() * loadFactor);	
	    
	    Random rRequests = new Random();
	    Random rEntry = new Random();
	    
	    int successfullRequests = 0;
	    
	    for (int i = 0; i < nbRequests; i++)
		{		
		    if (tree.interrogeLB(new RandomWord(insertedObjects[rRequests.nextInt(nbInsertedObjects)]), ring, rEntry) != -1)
			{
			    System.out.println("*** OK ***");
			    successfullRequests++;
	    		    }
		    else
			{
			    System.out.println("--- KO ---");
			}
		}
	    System.out.println("done.");
	    
	    /*
	     * Printing results of the requests
	     */
	    
	    // 	for (int i = 0; i < ring.getNbPeers(); i++)
	    // 	    {
	    // 		System.out.println("Peer " + i + "\n\t" + "Load = " + ring.peers[i].getLoad() + 
	    // 				   "\n\t" + "Capacity = " +  ring.peers[i].getCapacity());
	    // 	    }
	    
	    // 	for (int i = 0; i < tree.getNbNodes(); i++)
	    // 	    {
	    // 		System.out.println("Node " + i + " : " + tree.nodes[i].getID() + ", load = " + tree.nodes[i].getLoad());
	    // 	    }
	    double rate = (double)successfullRequests / (double)nbRequests;
	    return (rate);
	
   } // simulationStepNoLB

    private double simulationStepNoLBDyn(int step)
    {
	// inserting and removing peers

	System.out.print("Inserting and removing peers...");
	Random rID = new Random();
	Random rIDRemove = new Random();
	Random rCapacity = new Random();
	
	for (int i = 0; i < 10; i++)
	    {	
		Peer p = new Peer((new RandomWord(50, rID)).getString());
		p.setCapacity(rCapacity.nextInt(81) + 20); // to be tuned
		insertNoLoadBalancing(p);

		if (ring.getNbPeers() > 100) // if 101, removing one peer
		    ring.removePeer(rIDRemove.nextInt(ring.getNbPeers()), tree, ring);
	    }

	System.out.println("done.");
	
	// inserting objects

	System.out.print("Inserting objects...");

	for (int i = 0; i < nbObjects; i++)
	    {
		if (i % (int)(nbObjects/50) == step)
		    {
			RandomWord object = new RandomWord(objects[i]);
			
			if (!tree.present(object.getString()))
			    {
				int n = tree.inser(object, ring);
				insertedObjects[nbInsertedObjects++] = object.getString();
			    }
		    }
	    }
	
	System.out.println("done.");

	// checking the system

	System.out.println("Number of objects: " + tree.getNbNodes());

	for (int i = 0; i < tree.getNbNodes(); i++)
	    {
		System.out.print("Node" + i + " : " + tree.nodes[i].getID());
		System.out.print(" hosted by peer " + tree.nodes[i].getPeer() + " : ");
		System.out.println(ring.peers[tree.nodes[i].getPeer()].getID());
	    }
	
	for (int i = 0; i < ring.getNbPeers(); i++)
	    {
		System.out.println("Peer " + i + " : " + ring.peers[i].getID() + 
				   " with capacity " + ring.peers[i].getCapacity() +
			       " hosting :");
		int [] nodes = ring.peers[i].getNodes();
		for (int j = 0; j < ring.peers[i].getNbNodes(); j++)
		    {
			System.out.println(tree.nodes[nodes[j]].getID());
		    }
	    }

	    // reseting loads

	    System.out.print("Reseting peers' and nodes' load...");
	    ring.resetLoads();
	    tree.resetLoads();
	    System.out.println("done.");

	    // randomly requesting System.out.println("Requesting...");
	    
 	    int nbRequests = (int)(computeRingCapacity() * loadFactor);	
	    
	    Random rRequests = new Random();
	    Random rEntry = new Random();
	    
 	    int successfullRequests = 0;
	    
	    for (int i = 0; i < nbRequests; i++)
		{		
		    if (tree.interrogeLB(new RandomWord(insertedObjects[rRequests.nextInt(nbInsertedObjects)]), ring, rEntry) != -1)
			{
			    System.out.println("*** OK ***");
			    successfullRequests++;
	    		    }
		    else
			{
			    System.out.println("--- KO ---");
			}
		}
	    System.out.println("done.");
	    
	    /*
	     * Printing results of the requests
	     */
	    
	    // 	for (int i = 0; i < ring.getNbPeers(); i++)
	    // 	    {
	    // 		System.out.println("Peer " + i + "\n\t" + "Load = " + ring.peers[i].getLoad() + 
	    // 				   "\n\t" + "Capacity = " +  ring.peers[i].getCapacity());
	    // 	    }
	    
	    // 	for (int i = 0; i < tree.getNbNodes(); i++)
	    // 	    {
	    // 		System.out.println("Node " + i + " : " + tree.nodes[i].getID() + ", load = " + tree.nodes[i].getLoad());
	    // 	    }
	    double rate = (double)successfullRequests / (double)nbRequests;
	    return (rate);
	
   } // simulationStepNoLBDyn

    private double simulationStep(int step)
    {
	// random Load Balancing (in average
	// each node balances every 3 steps)

	System.out.print("Random load balancing...");
	int nbPeers = ring.getNbPeers();
	Random rPeers = new Random();

	for (int i = 0; i < nbPeers/3; i++)
	    {
		stepLoadBalancing(rPeers.nextInt(nbPeers));
	    }
	System.out.println("done.");

	// inserting peers with load balancing

	System.out.print("Inserting peers...");
	if (ring.getNbPeers() < 100)
	    {
		
		Random rID = new Random();
		Random rCapacity = new Random();
		
		int countInser = 0;
		while (countInser < 10) // to be tuned
		    {
			Peer p = new Peer((new RandomWord(50, rID)).getString());
			p.setCapacity(rCapacity.nextInt(81) + 20); // to be tuned
			if (insertLoadBalancing(p)) countInser++;
		    }
	    }
	System.out.println("done.");

	// Removing peers

	System.out.println("Removing peers...");
	
	if (ring.getNbPeers() > 20)
	{
		Random rRemove = new Random();
		for (int i = 0; i < 10; i++)
		    {
			ring.removePeer(rRemove.nextInt(ring.getNbPeers()), tree, ring);
		    }
	}
	System.out.println("done.");
	
	// inserting objects

	System.out.print("Inserting objects...");

	for (int i = 0; i < nbObjects; i++)
	    {
		if (i % (int)(nbObjects/50) == step)
		    {
			RandomWord object = new RandomWord(objects[i]);
			
			if (!tree.present(object.getString()))
			    {
				int n = tree.inser(object, ring);
				insertedObjects[nbInsertedObjects++] = object.getString();
			    }
		    }
	    }
	
	System.out.println("done.");

	// checking the system

	System.out.println("Number of objects: " + tree.getNbNodes());

	for (int i = 0; i < tree.getNbNodes(); i++)
	    {
		System.out.print("Node" + i + " : " + tree.nodes[i].getID());
		System.out.print(" hosted by peer " + tree.nodes[i].getPeer() + " : ");
		System.out.println(ring.peers[tree.nodes[i].getPeer()].getID());
	    }
	
	for (int i = 0; i < ring.getNbPeers(); i++)
	    {
		System.out.println("Peer " + i + " : " + ring.peers[i].getID() + 
				   " with capacity " + ring.peers[i].getCapacity() +
			       " hosting :");
		int [] nodes = ring.peers[i].getNodes();
		for (int j = 0; j < ring.peers[i].getNbNodes(); j++)
		    {
			System.out.println(tree.nodes[nodes[j]].getID());
		    }
	    }

	    // reseting loads

	    System.out.print("Reseting peers' and nodes' load...");
	    ring.resetLoads();
	    tree.resetLoads();
	    System.out.println("done.");

	    // randomly requesting System.out.println("Requesting...");
	    
	    int nbRequests = (int)(computeRingCapacity() * loadFactor);	
	    
	    Random rRequests = new Random();
	    Random rEntry = new Random();
	    
	    int successfullRequests = 0;
	    
	    for (int i = 0; i < nbRequests; i++)
		{		
		    if (tree.interrogeLB(new RandomWord(insertedObjects[rRequests.nextInt(nbInsertedObjects)]), ring, rEntry) != -1)
			{
			    System.out.println("*** OK ***");
			    successfullRequests++;
	    		    }
		    else
			{
			    System.out.println("--- KO ---");
			}
		}
	    System.out.println("done.");
	    
	    /*
	     * Printing results of the requests
	     */
	    
	    // 	for (int i = 0; i < ring.getNbPeers(); i++)
	    // 	    {
	    // 		System.out.println("Peer " + i + "\n\t" + "Load = " + ring.peers[i].getLoad() + 
	    // 				   "\n\t" + "Capacity = " +  ring.peers[i].getCapacity());
	    // 	    }
	    
	    // 	for (int i = 0; i < tree.getNbNodes(); i++)
	    // 	    {
	    // 		System.out.println("Node " + i + " : " + tree.nodes[i].getID() + ", load = " + tree.nodes[i].getLoad());
	    // 	    }
	    double rate = (double)successfullRequests / (double)nbRequests;
	    return (rate);
	
   } // simulationStep

    private double simulationStepDyn(int step)
    {
	// random Load Balancing (in average
	// each node balances every 3 steps)

	System.out.print("Random load balancing...");
	int nbPeers = ring.getNbPeers();
	Random rPeers = new Random();

	for (int i = 0; i < nbPeers/3; i++)
	    {
		stepLoadBalancing(rPeers.nextInt(nbPeers));
	    }
	System.out.println("done.");

	// inserting peers with load balancing and removing peers

	System.out.print("Inserting and removing peers...");
	Random rID = new Random();
	Random rIDRemove = new Random();
	Random rCapacity = new Random();
	
	for (int i = 0; i < 10; i++)
	    {	
		Peer p = new Peer((new RandomWord(50, rID)).getString());
		p.setCapacity(rCapacity.nextInt(81) + 20); // to be tuned
		insertNoLoadBalancing(p);

		if (ring.getNbPeers() > 100) // if 101, removing one peer
		    ring.removePeer(rIDRemove.nextInt(ring.getNbPeers()), tree, ring);
	    }

	System.out.println("done.");
	
	// inserting objects

	System.out.print("Inserting objects...");

	for (int i = 0; i < nbObjects; i++)
	    {
		if (i % (int)(nbObjects/50) == step)
		    {
			RandomWord object = new RandomWord(objects[i]);
			
			if (!tree.present(object.getString()))
			    {
				int n = tree.inser(object, ring);
				insertedObjects[nbInsertedObjects++] = object.getString();
			    }
		    }
	    }
	
	System.out.println("done.");

	// checking the system

	System.out.println("Number of objects: " + tree.getNbNodes());

	for (int i = 0; i < tree.getNbNodes(); i++)
	    {
		System.out.print("Node" + i + " : " + tree.nodes[i].getID());
		System.out.print(" hosted by peer " + tree.nodes[i].getPeer() + " : ");
		System.out.println(ring.peers[tree.nodes[i].getPeer()].getID());
	    }
	
	for (int i = 0; i < ring.getNbPeers(); i++)
	    {
		System.out.println("Peer " + i + " : " + ring.peers[i].getID() + 
				   " with capacity " + ring.peers[i].getCapacity() +
			       " hosting :");
		int [] nodes = ring.peers[i].getNodes();
		for (int j = 0; j < ring.peers[i].getNbNodes(); j++)
		    {
			System.out.println(tree.nodes[nodes[j]].getID());
		    }
	    }

	    // reseting loads

	    System.out.print("Reseting peers' and nodes' load...");
	    ring.resetLoads();
	    tree.resetLoads();
	    System.out.println("done.");

	    // randomly requesting System.out.println("Requesting...");
	    
	    int nbRequests = (int)(computeRingCapacity() * loadFactor);	
	    
	    Random rRequests = new Random();
	    Random rEntry = new Random();
	    
	    int successfullRequests = 0;
	    
	    for (int i = 0; i < nbRequests; i++)
		{		
		    if (tree.interrogeLB(new RandomWord(insertedObjects[rRequests.nextInt(nbInsertedObjects)]), ring, rEntry) != -1)
			{
			    System.out.println("*** OK ***");
			    successfullRequests++;
			}
		    else
			{
			    System.out.println("--- KO ---");
			}
		}
	    System.out.println("done.");
	    
	    /*
	     * Printing results of the requests
	     */
	    
	    // 	for (int i = 0; i < ring.getNbPeers(); i++)
	    // 	    {
	    // 		System.out.println("Peer " + i + "\n\t" + "Load = " + ring.peers[i].getLoad() + 
	    // 				   "\n\t" + "Capacity = " +  ring.peers[i].getCapacity());
	    // 	    }
	    
	    // 	for (int i = 0; i < tree.getNbNodes(); i++)
	    // 	    {
	    // 		System.out.println("Node " + i + " : " + tree.nodes[i].getID() + ", load = " + tree.nodes[i].getLoad());
	    // 	    }
	    double rate = (double)successfullRequests / (double)nbRequests;
	    return (rate);
	
   } // simulationStepDyn

    private double simulationStepkChoices(int step)
    {
	// inserting peers

	System.out.print("Inserting peers...");
	if (ring.getNbPeers() < 100)
	    {
		for (int i = 0; i < 10; i++)
		    {
			int k = 4;
			Random rID = new Random();
			Random rCapacity = new Random();
			String [] potentialStrings = new String [k];
			
			for (int j = 0; j < k; j++)
			    potentialStrings[j] = (new RandomWord(50, rID)).getString();
			
			insertkChoices(potentialStrings, k);
		    }
	    }
	System.out.println("done.");

	// Removing peers

// 	System.out.println("Removing peers...");
	
// 	if (ring.getNbPeers() > 20)
// 	{
// 		Random rRemove = new Random();
// 		for (int i = 0; i < 10; i++)
// 		    {
// 			ring.removePeer(rRemove.nextInt(ring.getNbPeers()), tree, ring);
// 		    }
// 	}
// 	System.out.println("done.");
	
	// inserting objects

	System.out.print("Inserting objects...");

	for (int i = 0; i < nbObjects; i++)
	    {
		if (i % (int)(nbObjects/50) == step)
		    {
			RandomWord object = new RandomWord(objects[i]);
			
			if (!tree.present(object.getString()))
			    {
				int n = tree.inser(object, ring);
				insertedObjects[nbInsertedObjects++] = object.getString();
			    }
		    }
	    }
	
	System.out.println("done.");

	// checking the system

	System.out.println("Number of objects: " + tree.getNbNodes());

	for (int i = 0; i < tree.getNbNodes(); i++)
	    {
		System.out.print("Node" + i + " : " + tree.nodes[i].getID());
		System.out.print(" hosted by peer " + tree.nodes[i].getPeer() + " : ");
		System.out.println(ring.peers[tree.nodes[i].getPeer()].getID());
	    }
	
	for (int i = 0; i < ring.getNbPeers(); i++)
	    {
		System.out.println("Peer " + i + " : " + ring.peers[i].getID() + 
				   " with capacity " + ring.peers[i].getCapacity() +
			       " hosting :");
		int [] nodes = ring.peers[i].getNodes();
		for (int j = 0; j < ring.peers[i].getNbNodes(); j++)
		    {
			System.out.println(tree.nodes[nodes[j]].getID());
		    }
	    }

	    // reseting loads

	    System.out.print("Reseting peers' and nodes' load...");
	    ring.resetLoads();
	    tree.resetLoads();
	    System.out.println("done.");

	    // randomly requesting System.out.println("Requesting...");
	    
 	    int nbRequests = (int)(computeRingCapacity() * loadFactor);	
	    
	    Random rRequests = new Random();
	    Random rEntry = new Random();
	    
 	    int successfullRequests = 0;
	    
	    for (int i = 0; i < nbRequests; i++)
		{		
		    if (tree.interrogeLB(new RandomWord(insertedObjects[rRequests.nextInt(nbInsertedObjects)]), ring, rEntry) != -1)
			{
			    System.out.println("*** OK ***");
			    successfullRequests++;
	    		    }
		    else
			{
			    System.out.println("--- KO ---");
			}
		}
	    System.out.println("done.");
	    
	    /*
	     * Printing results of the requests
	     */
	    
	    // 	for (int i = 0; i < ring.getNbPeers(); i++)
	    // 	    {
	    // 		System.out.println("Peer " + i + "\n\t" + "Load = " + ring.peers[i].getLoad() + 
	    // 				   "\n\t" + "Capacity = " +  ring.peers[i].getCapacity());
	    // 	    }
	    
	    // 	for (int i = 0; i < tree.getNbNodes(); i++)
	    // 	    {
	    // 		System.out.println("Node " + i + " : " + tree.nodes[i].getID() + ", load = " + tree.nodes[i].getLoad());
	    // 	    }
	    double rate = (double)successfullRequests / (double)nbRequests;
	    return (rate);
	
   } // simulationStepkChoices

    private double simulationStepkChoicesDyn(int step)
    {
	// inserting peers
	Random rID = new Random();
	Random rIDRemove = new Random();
	Random rCapacity = new Random();

	System.out.print("Inserting and removing peers...");
	for (int i = 0; i < 10; i++)
	    {
		int k = 4;
		String [] potentialStrings = new String [k];
		
		for (int j = 0; j < k; j++)
		    potentialStrings[j] = (new RandomWord(50, rID)).getString();
		
		insertkChoices(potentialStrings, k);

		if (ring.getNbPeers() > 100)
		    ring.removePeer(rIDRemove.nextInt(ring.getNbPeers()), tree, ring);
	    }
	System.out.println("done.");
	
	// inserting objects

	System.out.print("Inserting objects...");

	for (int i = 0; i < nbObjects; i++)
	    {
		if (i % (int)(nbObjects/50) == step)
		    {
			RandomWord object = new RandomWord(objects[i]);
			
			if (!tree.present(object.getString()))
			    {
				int n = tree.inser(object, ring);
				insertedObjects[nbInsertedObjects++] = object.getString();
			    }
		    }
	    }
	
	System.out.println("done.");

	// checking the system

	System.out.println("Number of objects: " + tree.getNbNodes());

	for (int i = 0; i < tree.getNbNodes(); i++)
	    {
		System.out.print("Node" + i + " : " + tree.nodes[i].getID());
		System.out.print(" hosted by peer " + tree.nodes[i].getPeer() + " : ");
		System.out.println(ring.peers[tree.nodes[i].getPeer()].getID());
	    }
	
	for (int i = 0; i < ring.getNbPeers(); i++)
	    {
		System.out.println("Peer " + i + " : " + ring.peers[i].getID() + 
				   " with capacity " + ring.peers[i].getCapacity() +
			       " hosting :");
		int [] nodes = ring.peers[i].getNodes();
		for (int j = 0; j < ring.peers[i].getNbNodes(); j++)
		    {
			System.out.println(tree.nodes[nodes[j]].getID());
		    }
	    }

	    // reseting loads

	    System.out.print("Reseting peers' and nodes' load...");
	    ring.resetLoads();
	    tree.resetLoads();
	    System.out.println("done.");

	    // randomly requesting System.out.println("Requesting...");
	    
 	    int nbRequests = (int)(computeRingCapacity() * loadFactor);	
	    
	    Random rRequests = new Random();
	    Random rEntry = new Random();
	    
 	    int successfullRequests = 0;
	    
	    for (int i = 0; i < nbRequests; i++)
		{		
		    if (tree.interrogeLB(new RandomWord(insertedObjects[rRequests.nextInt(nbInsertedObjects)]), ring, rEntry) != -1)
			{
			    System.out.println("*** OK ***");
			    successfullRequests++;
	    		    }
		    else
			{
			    System.out.println("--- KO ---");
			}
		}
	    System.out.println("done.");
	    
	    /*
	     * Printing results of the requests
	     */
	    
	    // 	for (int i = 0; i < ring.getNbPeers(); i++)
	    // 	    {
	    // 		System.out.println("Peer " + i + "\n\t" + "Load = " + ring.peers[i].getLoad() + 
	    // 				   "\n\t" + "Capacity = " +  ring.peers[i].getCapacity());
	    // 	    }
	    
	    // 	for (int i = 0; i < tree.getNbNodes(); i++)
	    // 	    {
	    // 		System.out.println("Node " + i + " : " + tree.nodes[i].getID() + ", load = " + tree.nodes[i].getLoad());
	    // 	    }
	    double rate = (double)successfullRequests / (double)nbRequests;
	    return (rate);
	
   } // simulationStepkChoicesDyn

    private double simulationStepDynEvolution(int step)
    {
	
	// random Load Balancing (in average
	// each node balances every 3 steps)

	System.out.print("Random load balancing...");
	int nbPeers = ring.getNbPeers();
	Random rPeers = new Random();

	for (int i = 0; i < nbPeers/3; i++)
	    {
		stepLoadBalancing(rPeers.nextInt(nbPeers));
	    }
	System.out.println("done.");

	// inserting peers with load balancing and removing peers

	System.out.print("Inserting and removing peers...");
	Random rID = new Random();
	Random rIDRemove = new Random();
	Random rCapacity = new Random();
	
	for (int i = 0; i < 10; i++)
	    {	
		Peer p = new Peer((new RandomWord(50, rID)).getString());
		p.setCapacity(rCapacity.nextInt(81) + 20); // to be tuned
		insertNoLoadBalancing(p);

		if (ring.getNbPeers() > 100) // if 101, removing one peer
		    ring.removePeer(rIDRemove.nextInt(ring.getNbPeers()), tree, ring);
	    }

	System.out.println("done.");
	
	// Loading all the services at once
	if (step == 0)
	    {
		System.out.print("Inserting objects...");
		
		for (int i = 0; i < nbObjects; i++)
		    {
			int n = tree.inser(new RandomWord(objects[i]), ring);
		    }
		
		System.out.println("done.");
	    }


	// checking the system

	System.out.println("Number of objects: " + tree.getNbNodes());

	for (int i = 0; i < tree.getNbNodes(); i++)
	    {
		System.out.print("Node" + i + " : " + tree.nodes[i].getID());
		System.out.print(" hosted by peer " + tree.nodes[i].getPeer() + " : ");
		System.out.println(ring.peers[tree.nodes[i].getPeer()].getID());
	    }
	
	for (int i = 0; i < ring.getNbPeers(); i++)
	    {
		System.out.println("Peer " + i + " : " + ring.peers[i].getID() + 
				   " with capacity " + ring.peers[i].getCapacity() +
			       " hosting :");
		int [] nodes = ring.peers[i].getNodes();
		for (int j = 0; j < ring.peers[i].getNbNodes(); j++)
		    {
			System.out.println(tree.nodes[nodes[j]].getID());
		    }
	    }

	    // reseting loads

	    System.out.print("Reseting peers' and nodes' load...");
	    ring.resetLoads();
	    tree.resetLoads();
	    System.out.println("done.");

	    // randomly requesting System.out.println("Requesting...");
	    
	    int nbRequests = (int)(computeRingCapacity() * loadFactor);	
	    
	    Random rRequests = new Random();
	    Random rEntry = new Random();
	    
	    int successfullRequests = 0;
	    
	    if (step < 40)
		{
		    
		    for (int i = 0; i < nbRequests; i++)
			{
			    RandomWord rword = new RandomWord(objects[rRequests.nextInt(nbObjects)]);
			    System.out.println("Step n " + step + " : requested service " + rword.getString());
			    
			    if (tree.interrogeLB(rword, ring, rEntry) != -1)
				{
				    System.out.println("*** OK ***");
				    successfullRequests++;
				}
			    else
				{
				    System.out.println("--- KO ---");
				}
			}
		}

	    else if (step < 80)
		// du S3L (index entre 0 et 41)
		{
		    for (int i = 0; i < nbRequests; i++)
			{
			    RandomWord rword = new RandomWord(objects[rRequests.nextInt(42)]);
			    System.out.println("Step n " + step + " : requested service " + rword.getString());

			    if (tree.interrogeLB(rword, ring, rEntry) != -1)
				{
				    System.out.println("*** OK ***");
				    successfullRequests++;
				}
			    else
				{
				    System.out.println("--- KO ---");
				}
			}
		}


	    else if (step < 120)
		// du ScaLAPACK (index entre 712 et 735)
		{
		    for (int i = 0; i < nbRequests; i++)
			{
			    RandomWord rword = new RandomWord(objects[rRequests.nextInt(24) + nbObjects - 24]);
			    System.out.println("Step n " + step + " : requested service " + rword.getString());

			    if (tree.interrogeLB(rword, ring, rEntry) != -1)
				{
				    System.out.println("*** OK ***");
				    successfullRequests++;
				}
			    else
				{
				    System.out.println("--- KO ---");
				}
			}
		}
	    else
		// Random
		{
		    for (int i = 0; i < nbRequests; i++)
			{
			    RandomWord rword = new RandomWord(objects[rRequests.nextInt(nbObjects)]);
			    System.out.println("Step n " + step + " : requested service " + rword.getString());

			    if (tree.interrogeLB(rword, ring, rEntry) != -1)
				{
				    System.out.println("*** OK ***");
				    successfullRequests++;
				}
			    else
				{
				    System.out.println("--- KO ---");
				}
			}
		}
	    

	    System.out.println("done.");
	    
	    /*
	     * Printing results of the requests
	     */
	    
	    // 	for (int i = 0; i < ring.getNbPeers(); i++)
	    // 	    {
	    // 		System.out.println("Peer " + i + "\n\t" + "Load = " + ring.peers[i].getLoad() + 
	    // 				   "\n\t" + "Capacity = " +  ring.peers[i].getCapacity());
	    // 	    }
	    
	    // 	for (int i = 0; i < tree.getNbNodes(); i++)
	    // 	    {
	    // 		System.out.println("Node " + i + " : " + tree.nodes[i].getID() + ", load = " + tree.nodes[i].getLoad());
	    // 	    }
	    double rate = (double)successfullRequests / (double)nbRequests;
	    return (rate);
	
   } // simulationStepDynEvolution


    private void insertkChoices(String [] potentialIDs, int k)
    {
	// affichage
	System.out.println("IDs potentielles: ");
	for (int i = 0; i < k; i++)
	    {
		System.out.println("\t" + potentialIDs[i]);
	    }
	
	
	Peer bestPeer = null;
	int min = 100000;
	
	Random rCapacity = new Random();
	int capacityLoc = rCapacity.nextInt(81) + 20;

	for (int i = 0; i < k; i++)
	    {
		System.out.println("--------------------------");
		System.out.println("ID " + i + ", " + potentialIDs[i]);
		
		Peer p = new Peer(potentialIDs[i]);
		insertNoLoadBalancing(p);
		p.setCapacity(capacityLoc);
		
		int indexLoc = p.getIndex();
		int indexSucc;
		if (indexLoc == ring.getNbPeers() - 1)
		    indexSucc = 0;
		else
		    indexSucc = indexLoc + 1;
		
		System.out.println("ID succ " + ring.peers[indexSucc].getID());
		
		int [] nodesLoc = p.getNodes();
		int [] nodesSucc = ring.peers[indexSucc].getNodes();

		int nbNodesLoc = p.getNbNodes();
		int nbNodesSucc = ring.peers[indexSucc].getNbNodes();

		System.out.println("Nodes of loc :");
		for (int j = 0; j < nbNodesLoc; j++)
		    {
			
			System.out.println("Node " + nodesLoc[j] + ", " + 
					   tree.nodes[nodesLoc[j]].getID());
		    }
		System.out.println("Nodes of succ :");
		for (int j = 0; j < nbNodesSucc; j++)
		    {
			
			System.out.println("Node " + nodesSucc[j] + ", " + 
					   tree.nodes[nodesSucc[j]].getID());
		    }
		int loadLoc = 0;
		int loadSucc = 0;
		
		for (int j = 0; j < nbNodesLoc; j++)
		    loadLoc += tree.nodes[nodesLoc[j]].getLoad();
		for (int j = 0; j < nbNodesSucc; j++)
		    loadSucc += tree.nodes[nodesSucc[j]].getLoad();

		System.out.println("Load Loc : " + loadLoc);
		System.out.println("Load Succ : " + loadSucc);

		int c = Math.abs((ring.peers[indexSucc].getCapacity())/2 - loadSucc)
			    + Math.abs((p.getCapacity())/2 - loadLoc)
			    - Math.abs((ring.peers[indexSucc].getCapacity())/2 - (loadLoc + loadSucc));
		System.out.println("c = " + c);
		if (c < min)
		    {
			min = c;
			bestPeer = p;
		    }
		ring.removePeer(p.getIndex(), tree, ring);	
	    }
	
	insertNoLoadBalancing(bestPeer);
	
    } // kChoices
    

    private double simulationStepNoLBDynEvolution(int step)
    {
	// inserting and removing peers

	System.out.print("Inserting and removing peers...");
	Random rID = new Random();
	Random rIDRemove = new Random();
	Random rCapacity = new Random();
	
	for (int i = 0; i < 10; i++)
	    {	
		Peer p = new Peer((new RandomWord(50, rID)).getString());
		p.setCapacity(rCapacity.nextInt(81) + 20); // to be tuned
		insertNoLoadBalancing(p);

		if (ring.getNbPeers() > 100) // if 101, removing one peer
		    ring.removePeer(rIDRemove.nextInt(ring.getNbPeers()), tree, ring);
	    }

	System.out.println("done.");
	
	// inserting objects

	System.out.print("Inserting objects...");

	for (int i = 0; i < nbObjects; i++)
	    {
		if (i % (int)(nbObjects/50) == step)
		    {
			RandomWord object = new RandomWord(objects[i]);
			
			if (!tree.present(object.getString()))
			    {
				int n = tree.inser(object, ring);
				insertedObjects[nbInsertedObjects++] = object.getString();
			    }
		    }
	    }
	
	System.out.println("done.");

	// checking the system

	System.out.println("Number of objects: " + tree.getNbNodes());

	for (int i = 0; i < tree.getNbNodes(); i++)
	    {
		System.out.print("Node" + i + " : " + tree.nodes[i].getID());
		System.out.print(" hosted by peer " + tree.nodes[i].getPeer() + " : ");
		System.out.println(ring.peers[tree.nodes[i].getPeer()].getID());
	    }
	
	for (int i = 0; i < ring.getNbPeers(); i++)
	    {
		System.out.println("Peer " + i + " : " + ring.peers[i].getID() + 
				   " with capacity " + ring.peers[i].getCapacity() +
			       " hosting :");
		int [] nodes = ring.peers[i].getNodes();
		for (int j = 0; j < ring.peers[i].getNbNodes(); j++)
		    {
			System.out.println(tree.nodes[nodes[j]].getID());
		    }
	    }

	    // reseting loads

	    System.out.print("Reseting peers' and nodes' load...");
	    ring.resetLoads();
	    tree.resetLoads();
	    System.out.println("done.");


	    // randomly requesting System.out.println("Requesting...");
	    
 	    int nbRequests = (int)(computeRingCapacity() * loadFactor);	
	    
	    Random rRequests = new Random();
	    Random rEntry = new Random();
	    
 	    int successfullRequests = 0;

	    if (step < 40)
		{
		    
		    for (int i = 0; i < nbRequests; i++)
			{
			    RandomWord rword = new RandomWord(objects[rRequests.nextInt(nbObjects)]);
			    System.out.println("Step n " + step + " : requested service " + rword.getString());
			    
			    if (tree.interrogeLB(rword, ring, rEntry) != -1)
				{
				    System.out.println("*** OK ***");
				    successfullRequests++;
				}
			    else
				{
				    System.out.println("--- KO ---");
				}
			}
		}

	    else if (step < 80)
		// du S3L (index entre 0 et 41)
		{
		    for (int i = 0; i < nbRequests; i++)
			{
			    RandomWord rword = new RandomWord(objects[rRequests.nextInt(42)]);
			    System.out.println("Step n " + step + " : requested service " + rword.getString());

			    if (tree.interrogeLB(rword, ring, rEntry) != -1)
				{
				    System.out.println("*** OK ***");
				    successfullRequests++;
				}
			    else
				{
				    System.out.println("--- KO ---");
				}
			}
		}


	    else if (step < 120)
		// du ScaLAPACK (index entre 712 et 735)
		{
		    for (int i = 0; i < nbRequests; i++)
			{
			    RandomWord rword = new RandomWord(objects[rRequests.nextInt(24) + nbObjects - 24]);
			    System.out.println("Step n " + step + " : requested service " + rword.getString());

			    if (tree.interrogeLB(rword, ring, rEntry) != -1)
				{
				    System.out.println("*** OK ***");
				    successfullRequests++;
				}
			    else
				{
				    System.out.println("--- KO ---");
				}
			}
		}
	    else
		// Random
		{
		    for (int i = 0; i < nbRequests; i++)
			{
			    RandomWord rword = new RandomWord(objects[rRequests.nextInt(nbObjects)]);
			    System.out.println("Step n " + step + " : requested service " + rword.getString());

			    if (tree.interrogeLB(rword, ring, rEntry) != -1)
				{
				    System.out.println("*** OK ***");
				    successfullRequests++;
				}
			    else
				{
				    System.out.println("--- KO ---");
				}
			}
		}
	    

	    System.out.println("done.");
	    
	    /*
	     * Printing results of the requests
	     */
	    
	    // 	for (int i = 0; i < ring.getNbPeers(); i++)
	    // 	    {
	    // 		System.out.println("Peer " + i + "\n\t" + "Load = " + ring.peers[i].getLoad() + 
	    // 				   "\n\t" + "Capacity = " +  ring.peers[i].getCapacity());
	    // 	    }
	    
	    // 	for (int i = 0; i < tree.getNbNodes(); i++)
	    // 	    {
	    // 		System.out.println("Node " + i + " : " + tree.nodes[i].getID() + ", load = " + tree.nodes[i].getLoad());
	    // 	    }
	    double rate = (double)successfullRequests / (double)nbRequests;
	    return (rate);
	
   } // simulationStepNoLBDynEvolution


    private double simulationStepkChoicesDynEvolution(int step)
    {
	// inserting peers
	Random rID = new Random();
	Random rIDRemove = new Random();
	Random rCapacity = new Random();

	System.out.print("Inserting and removing peers...");
	for (int i = 0; i < 10; i++)
	    {
		int k = 4;
		String [] potentialStrings = new String [k];
		
		for (int j = 0; j < k; j++)
		    potentialStrings[j] = (new RandomWord(50, rID)).getString();
		
		insertkChoices(potentialStrings, k);

		if (ring.getNbPeers() > 100)
		    ring.removePeer(rIDRemove.nextInt(ring.getNbPeers()), tree, ring);
	    }
	System.out.println("done.");
	
	// inserting objects

	System.out.print("Inserting objects...");

	for (int i = 0; i < nbObjects; i++)
	    {
		if (i % (int)(nbObjects/50) == step)
		    {
			RandomWord object = new RandomWord(objects[i]);
			
			if (!tree.present(object.getString()))
			    {
				int n = tree.inser(object, ring);
				insertedObjects[nbInsertedObjects++] = object.getString();
			    }
		    }
	    }
	
	System.out.println("done.");

	// checking the system

	System.out.println("Number of objects: " + tree.getNbNodes());

	for (int i = 0; i < tree.getNbNodes(); i++)
	    {
		System.out.print("Node" + i + " : " + tree.nodes[i].getID());
		System.out.print(" hosted by peer " + tree.nodes[i].getPeer() + " : ");
		System.out.println(ring.peers[tree.nodes[i].getPeer()].getID());
	    }
	
	for (int i = 0; i < ring.getNbPeers(); i++)
	    {
		System.out.println("Peer " + i + " : " + ring.peers[i].getID() + 
				   " with capacity " + ring.peers[i].getCapacity() +
			       " hosting :");
		int [] nodes = ring.peers[i].getNodes();
		for (int j = 0; j < ring.peers[i].getNbNodes(); j++)
		    {
			System.out.println(tree.nodes[nodes[j]].getID());
		    }
	    }

	    // reseting loads

	    System.out.print("Reseting peers' and nodes' load...");
	    ring.resetLoads();
	    tree.resetLoads();
	    System.out.println("done.");

	    // randomly requesting System.out.println("Requesting...");
	    
 	    int nbRequests = (int)(computeRingCapacity() * loadFactor);	
	    
	    Random rRequests = new Random();
	    Random rEntry = new Random();
	    
 	    int successfullRequests = 0;


	    if (step < 40)
		{
		    
		    for (int i = 0; i < nbRequests; i++)
			{
			    RandomWord rword = new RandomWord(objects[rRequests.nextInt(nbObjects)]);
			    System.out.println("Step n " + step + " : requested service " + rword.getString());
			    
			    if (tree.interrogeLB(rword, ring, rEntry) != -1)
				{
				    System.out.println("*** OK ***");
				    successfullRequests++;
				}
			    else
				{
				    System.out.println("--- KO ---");
				}
			}
		}

	    else if (step < 80)
		// du S3L (index entre 0 et 41)
		{
		    for (int i = 0; i < nbRequests; i++)
			{
			    RandomWord rword = new RandomWord(objects[rRequests.nextInt(42)]);
			    System.out.println("Step n " + step + " : requested service " + rword.getString());

			    if (tree.interrogeLB(rword, ring, rEntry) != -1)
				{
				    System.out.println("*** OK ***");
				    successfullRequests++;
				}
			    else
				{
				    System.out.println("--- KO ---");
				}
			}
		}


	    else if (step < 120)
		// du ScaLAPACK (index entre 712 et 735)
		{
		    for (int i = 0; i < nbRequests; i++)
			{
			    RandomWord rword = new RandomWord(objects[rRequests.nextInt(24) + nbObjects - 24]);
			    System.out.println("Step n " + step + " : requested service " + rword.getString());

			    if (tree.interrogeLB(rword, ring, rEntry) != -1)
				{
				    System.out.println("*** OK ***");
				    successfullRequests++;
				}
			    else
				{
				    System.out.println("--- KO ---");
				}
			}
		}
	    else
		// Random
		{
		    for (int i = 0; i < nbRequests; i++)
			{
			    RandomWord rword = new RandomWord(objects[rRequests.nextInt(nbObjects)]);
			    System.out.println("Step n " + step + " : requested service " + rword.getString());

			    if (tree.interrogeLB(rword, ring, rEntry) != -1)
				{
				    System.out.println("*** OK ***");
				    successfullRequests++;
				}
			    else
				{
				    System.out.println("--- KO ---");
				}
			}
		}

	    
	    System.out.println("done.");
	    
	    /*
	     * Printing results of the requests
	     */
	    
	    // 	for (int i = 0; i < ring.getNbPeers(); i++)
	    // 	    {
	    // 		System.out.println("Peer " + i + "\n\t" + "Load = " + ring.peers[i].getLoad() + 
	    // 				   "\n\t" + "Capacity = " +  ring.peers[i].getCapacity());
	    // 	    }
	    
	    // 	for (int i = 0; i < tree.getNbNodes(); i++)
	    // 	    {
	    // 		System.out.println("Node " + i + " : " + tree.nodes[i].getID() + ", load = " + tree.nodes[i].getLoad());
	    // 	    }
	    double rate = (double)successfullRequests / (double)nbRequests;
	    return (rate);
	
   } // simulationStepkChoicesDynEvolution


    private void runSimulation()
    {
	loadFactor = 0.00625;
	int nbRun = 50;

	int nbSteps = 160;
	double [] rates = new double[nbSteps];
	
	for (int ct = 0; ct < nbRun; ct++)
	    {
		// init

		tree = new Tree();
		ring = new Ring();

		insertedObjects = new String [nbObjects];
		nbInsertedObjects = 0;
	
		// simulation

		for (int i = 0; i < nbSteps; i++)
		    {
			rates[i] += simulationStepDynEvolution(i);
		    }

		// printing
	
		File file = null;
	
		try {
		    file = new File(".", "resultat.dat");
		    file.createNewFile();
	    
		    FileWriter fw = new FileWriter(file, true);
		    for (int i = 0; i < nbSteps; i++)
			fw.write(round(rates[i],3) + "\n");
		    fw.write("\n");
	    
		    fw.close();
		}
		catch (IOException ioe) {
		    ioe.printStackTrace();
		}
	    }

	// average

	System.out.println("Average");
	
	File file = null;
	
	try {
	    file = new File(".", "resultat.dat");
	    file.createNewFile();
	    
	    FileWriter fw = new FileWriter(file, true);
	    for (int i = 0; i < nbSteps; i++)
		fw.write(i + "\t" + round((double)rates[i]/(double)nbRun,3) + "\n");
	    fw.write("\n");
	    
	    fw.close();
	}
	catch (IOException ioe) {
	    ioe.printStackTrace();
	}
	
    } // runSimulation

    public static void main (String args[])
    {
		Simulator s = new Simulator();
		s.runSimulation();

    } // main
} // simulator
