import java.util.*;
import java.io.*;

class Tree
{

    Node [] nodes;
    int nbNodes;

    int root;

    Tree ()
    {
	nodes = new Node [2000];
	nbNodes = 0;
    } // Tree

    int getIndexFromID(String _ID)
    {
	int i;
	
	for (i = 0; i < nbNodes; i++)
	    {
		if (nodes[i].getID().compareTo(_ID) == 0)
			break;
	    }

	return(i);
    } // getIndexFromID

    /*
     * Test if there's a node labeled by a given string in the tree
     * @param s String to be tested
     * @return true if present, false otherwise
     */
    public boolean present (String s)
    {
	for (int i = 0; i < nbNodes; i++)
	    {
		if (nodes[i].getID().compareTo(s) == 0)
		    return(true);
	    }
	return(false);
    } // present

    public int getNbNodes ()
    {
	return (nbNodes);
    }

    public int getRoot()
    {
	return(root);
    }

    /*
     * Insert a new label in the tree
     * @param label RandomWord to be inserted
     * @param ring Ring
     * @return the number of hops
     */
    public int inser (RandomWord label, Ring ring)
    {
	
	int nbs = 0;

	if (nbNodes == 0) // First node -> root
	    {
		nodes[nbNodes] = new Node(label.getString());
		nodes[nbNodes].map(ring);
		ring.peers[nodes[nbNodes].getPeer()].addNode(nbNodes, this, ring);

		nbNodes++;
		root = 0;
	    }
	else
	    {
		boolean processed = false;
		Random entree = new Random();
		int noeudCourant = entree.nextInt(nbNodes);
		
		while (!processed) // insere ou deja present
		    {
			if (label.getString().compareTo(nodes[noeudCourant].getID()) == 0)
			    {
				processed = true;
				// System.out.println(label.getString() + " deja dans la DHT");
			    }
			else if (label.getString().startsWith(nodes[noeudCourant].getID()))
			    // Nouveau extension du courant (courant eventuellement string vide)
			    {
				// Calcul de la taille du courant
				int tailleCourant = nodes[noeudCourant].getID().length();
				// Recherche d'un fils qui partage un caractere supplementaire
				
				// System.out.println(label.getString() + " extension de " + nodes[noeudCourant].getID());
				boolean forwarded = false;
				for (int f = 0; f < nodes[noeudCourant].getNbChildren(); f++)
				    {
					if (nodes[noeudCourant].getThisChild(f) != -1)
					    {
						
						//	System.out.println("Test du fils: " + nodes[nodes[noeudCourant].getThisChild(f)].getID());
						//if (label.getString().startsWith(nodes[nodes[noeudCourant].getThisChild(f)].getID()))
						if (label.getString().charAt(tailleCourant) == 
						    nodes[nodes[noeudCourant].getThisChild(f)].getID().charAt(tailleCourant))
						    // Trouve fils du courant partageant plus de caractere que le courant
						    {
							// System.out.println("Transmission de: " + label.getString() 
							// 	   + " a: " + nodes[nodes[noeudCourant].getThisChild(f)].getID());
							noeudCourant = nodes[noeudCourant].getThisChild(f);
							forwarded = true;
							nbs++;
							break;
						    }
					    }
					else
					    {
						// Si ce fils tait destinataire de la requte, il y a peut-tre deux nodess qui se construisent
						// qu'il faudra fusionner
						System.out.println("Je suis " + nodes[noeudCourant].getID() + " et j'ai un fils mort");
						
					    }
				    }
				if ((!forwarded) && (label.getString().compareTo(nodes[noeudCourant].getID()) != 0))
				    // Nouveau extension du courant, non transmis a un fils et non egal au noeud courant
				    // c'est donc un fils du noeud courant
				    {
					nodes[nbNodes] = new Node(label.getString());
					nodes[nbNodes].map(ring);
					ring.peers[nodes[nbNodes].getPeer()].addNode(nbNodes, this, ring);
					nodes[nbNodes].setIndex(nbNodes);
					nodes[nbNodes].setParent(noeudCourant);
					nodes[noeudCourant].addChild(nbNodes);
					
// 					System.out.println("Insertion de: " + label.getString() 
// 							   + " sous " + nodes[nodes[nbNodes].getParent()].getID());
					nbNodes++;
					processed = true;
				    }
			    }
			else if (nodes[noeudCourant].getID().startsWith(label.getString()))
			    {
				// le courant est une extension du nouveau

// 				System.out.println("Le noeud courant " + nodes[noeudCourant].getID() + 
// 						   " est une extension du nouveau : " + label.getString());
				
				// >= 0 signifie ni -1 (je suis la root) ni -2 mon pre est mort (et je suis en phase de rparation)
				// Si j'ai un pre et que ce pre est gal ou prfixe du noeud courant
				if ((nodes[noeudCourant].getParent() >= 0) &&
				    ((nodes[nodes[noeudCourant].getParent()].getID().compareTo(label.getString()) == 0) ||
				     (nodes[nodes[noeudCourant].getParent()].getID().startsWith(label.getString()))))
				    
				    {
// 					System.out.println("Le parent " + nodes[nodes[noeudCourant].getParent()].getID() + 
// 							   " est egal au nouveau ou une extension du nouveau" );
// 					System.out.println("Transmission au parent.");
					noeudCourant = nodes[noeudCourant].getParent();
					nbs++;
				    }
				else // que je sois la vrai ou une fausse root, le nouveau noeud est mon pre
				    {

					nodes[nbNodes] = new Node(label.getString());
					nodes[nbNodes].map(ring);
					ring.peers[nodes[nbNodes].getPeer()].addNode(nbNodes, this, ring);
					nodes[nbNodes].setIndex(nbNodes);
					nodes[nbNodes].setParent(nodes[noeudCourant].getParent());
					nodes[nbNodes].addChild(nodes[noeudCourant].getIndex());
					if (nodes[noeudCourant].getParent() >= 0)
					    // Si j'ai dj un pre (donc mon pre n'est pas gal ni extension du nouveau noeud)
					    // le nouveau est entre moi et mon pre
					    {
						// Le fils de mon pre (moi) change (devient le nouveau noeud)
						for (int cas = 0; cas < nodes[nodes[noeudCourant].getParent()].getNbChildren(); cas++)
						    {
							if (nodes[nodes[noeudCourant].getParent()].getThisChild(cas) == noeudCourant)
							    {
// 								System.out.print("Modification fils, le fils : " 
// 										 + nodes[nodes[nodes[noeudCourant].getParent()].getThisChild(cas)].getID()
// 										 + " devient ");
								nodes[nodes[noeudCourant].getParent()].setChild(cas, nbNodes);
								// System.out.println(nodes[nodes[nodes[noeudCourant].getParent()].getThisChild(cas)].getID());
								break;
							    }
						    }
					    }
					else
					    {
						System.out.println("Nouvelle root: " + nodes[nbNodes].getID());
						root = nbNodes;
					    }
					nodes[noeudCourant].setParent(nbNodes);
					nbNodes++;
					processed = true;
				    }
				
			    }
			else
			    {
				// System.out.println(label.getString() + " pas egale et pas extension de " + nodes[noeudCourant].getID());
				// Le nouveau noeud est mon frere

				// Calcul du nom du nouveau parent
				char communTemp [] = new char [50];
				int c;
				// on ne peut pas depasser la taille des strings utilisees (de toute facon ca sert a rien)
				// Tant qu'on a des caractres en commun
				for (c = 0; ((label.getString().length() > c) && (nodes[noeudCourant].getID().length() > c) 
					     && (label.getString().charAt(c) == nodes[noeudCourant].getID().charAt(c))); c++)
				    {
					// On rajoute le caractere en commun
					communTemp[c] = label.getString().charAt(c);
				    }

				char commun [] = new char [c];
			        for (int vux = 0; vux < c; vux++)
				    commun[vux] = communTemp[vux];

				String temp = new String(commun);
// 				System.out.println("String des caracteres communs: " + temp);
// 				System.out.println("Taille: " + temp.length());

				if ((nodes[noeudCourant].getParent() >= 0) &&
				     (nodes[nodes[noeudCourant].getParent()].getID().startsWith(new String(commun))))
				    {
					//	System.out.println(nodes[nodes[noeudCourant].getParent()].getID() + " commence par " + new String(commun));
				    }

				if ((nodes[noeudCourant].getParent() == -1) ||
				    ((nodes[noeudCourant].getParent() >= 0) &&
				     (nodes[nodes[noeudCourant].getParent()].getID().compareTo(new String(commun)) != 0) &&
				     (!nodes[nodes[noeudCourant].getParent()].getID().startsWith(new String(commun)))))
				    {

					// allocation d'une string de la taille du nombre de caracteres en commun
					char nomParentChar [] = new char [c];
					for (int r = 0; r < c; r++)
					    nomParentChar[r] = commun[r];
					String nomParent = new String (nomParentChar);
					
					// Insertion nouveau noeud
					nodes[nbNodes] = new Node(label.getString());
					nodes[nbNodes].map(ring);
					ring.peers[nodes[nbNodes].getPeer()].addNode(nbNodes, this, ring);
					nodes[nbNodes].setIndex(nbNodes);
					nodes[nbNodes].setParent(nbNodes + 1);
					nbNodes++;
					
					// Insertion nouveau parent
					nodes[nbNodes] = new Node(nomParent);
					nodes[nbNodes].map(ring);
					ring.peers[nodes[nbNodes].getPeer()].addNode(nbNodes, this, ring);
					nodes[nbNodes].setIndex(nbNodes);
					nodes[nbNodes].setParent(nodes[noeudCourant].getParent());
					nodes[nbNodes].addChild(nodes[noeudCourant].getIndex());
					nodes[nbNodes].addChild(nbNodes - 1);					
					
					// Modification de la reference a son fils du parent du noeud courant
					if (nodes[noeudCourant].getParent() >= 0)
					    {
						for (int rep = 0; rep < nodes[nodes[noeudCourant].getParent()].getNbChildren(); rep++)
						    {
							if (nodes[nodes[noeudCourant].getParent()].getThisChild(rep) == noeudCourant)
							    {
								nodes[nodes[noeudCourant].getParent()].setChild(rep, nbNodes);
								break;
							    }
						    }
					    }
					
					// Modif Parent du noeud courant
					nodes[noeudCourant].setParent(nbNodes);
					
// 					System.out.println("Creation noeud: " + nodes[nbNodes].getID());
// 					System.out.println("Insertion noeud: " + nodes[nbNodes - 1].getID() + 
// 							   " sous " + nodes[nodes[nbNodes - 1].getParent()].getID());
					
					// si le noeud qui a traite etait la root, le parent devient la root
					if (nodes[nbNodes].getParent() == -1)
					    root = nbNodes;
					nbNodes++;
					processed = true;
				    }
				else
				    {
					
					noeudCourant = nodes[noeudCourant].getParent();
					nbs++;
				    }
			    }
		    }
		
		//		System.out.println("Nb Sauts: " + nbs + "\n");
	    }
	return (nbs);
    } // INSER

    // Parcours dans l'ordre du tableau
    public void parcours ()
    {
	for (int j = 0; j < nbNodes; j++)
	    {
		
		System.out.println("Nom du noeud: " + nodes[j].getID());
		System.out.println("Nom des fils :");
		
		for (int nbf = 0; nbf < nodes[j].getNbChildren(); nbf++)
		    {
			if (nodes[j].getThisChild(nbf) != -1)
			    System.out.print(nodes[nodes[j].getThisChild(nbf)].getID() + "\t");
		    }
		System.out.print("\n");
	    }
	
	System.out.println("Nom du noeud root: " + nodes[root].getID());
	System.out.println("Nombre de noeuds: " + nbNodes);

    } // PARCOURS

    /*
     * Route an interrogation request taking into account the capacity of peers
     * @param label object ID requested
     * @param ring physical network (to obtain capacities)
     * @return number of hops if successfully routed -1 otherwise
     */

    public int interrogeLB (RandomWord label, Ring ring, Random entry)
    {
	// compteur de sauts logiques pour cette requete
	int nbs = 0;

	// Insertion Node
	if (nbNodes == 0) // Premier noeud -> Root
	    {
		System.out.println("Nodes vide, STOP");
	    }
	else
	    {
		boolean processed = false;
		int noeudCourant = entry.nextInt(nbNodes);
		
		while (!processed)
		    {
			System.out.println("Node courant: " + noeudCourant);
			System.out.println("Peer du noeud courant: " + nodes[noeudCourant].getPeer());
			/* Increment the load on the peer hosting the current node and test the capacity of the peer */
			nodes[noeudCourant].incLoad();
			ring.peers[nodes[noeudCourant].getPeer()].incLoad();
			if (ring.peers[nodes[noeudCourant].getPeer()].getLoad() > ring.peers[nodes[noeudCourant].getPeer()].getCapacity())
			{
			    return(-1);
			}

			if (label.getString().compareTo(nodes[noeudCourant].getID()) == 0)
			    {
				processed = true;
// 				System.out.println ("Le noeud courant est: " + nodes[noeudCourant].getID());
// 				System.out.println("TROUVE.");

			    }
			else if (label.getString().startsWith(nodes[noeudCourant].getID()))
			    // Nouveau extension du courant (extension string vide ca marche)
			    {
				// Calcul de la taille du courant
				int tailleCourant = nodes[noeudCourant].getID().length();

				// Recherche d'un fils qui partage un caractere supplementaire				
				//	System.out.println(label.getString() + " extension de " + nodes[noeudCourant].getID());
				boolean forwarded = false;
				for (int f = 0; f < nodes[noeudCourant].getNbChildren(); f++)
				    {
					//	System.out.println("Test du fils: " + nodes[nodes[noeudCourant].getThisChild(f)].getID());
					if ((nodes[noeudCourant].getThisChild(f) != -1) && (label.getString().charAt(tailleCourant) == 
					      nodes[nodes[noeudCourant].getThisChild(f)].getID().charAt(tailleCourant)))
					    // Trouve fils du courant partageant plus de caractere que le courant
					    {
// 						System.out.println("Transmission de: " + label.getString() 
// 								   + " a: " + nodes[nodes[noeudCourant].getThisChild(f)].getID());
						noeudCourant = nodes[noeudCourant].getThisChild(f);
						forwarded = true;
						nbs++;
						break;
					    }
				    }
				if ((!forwarded) && (label.getString().compareTo(nodes[noeudCourant].getID()) != 0))
				    // Nouveau extension du courant, pas de fils mieux. STOP
				    {
					// System.out.println (nodes[noeudCourant].getID() + " n'a pas de fils pour transmettre la requete " + 
// 							    label.getString() + "... STOP!");
					processed = true;
				    }
			    }
			else if (nodes[noeudCourant].getID().startsWith(label.getString()))
			    // Courant extension du nouveau -> Au dessus
			    // Je transmets a mon parent que s'il prefixe aussi
			    {
// 				System.out.println("Le courant " + nodes[noeudCourant].getID() + 
// 						   " est une extension du nouveau " + label.getString());
				
				if (nodes[noeudCourant].getParent() < 0)
				    { 
// 					System.out.println("Je ne peux ni descendre ni monter... STOP");
 					processed = true;
				    }
				else if (nodes[nodes[noeudCourant].getParent()].getID().startsWith(label.getString()))
				    {
// 					System.out.println("Transmission au parent " + nodes[nodes[noeudCourant].getParent()].getID() + 
// 							   " qui est aussi prefixe par " + label.getString());
					noeudCourant = nodes[noeudCourant].getParent();
					nbs++;
				    }
				else
				    // Je suis prefixe mais pas mon parent
				    {
// 					System.out.println("Le noeud courant " + nodes[noeudCourant].getID() + 
// 							   " est prefixe par le nouveau " + label.getString() + 
// 							   " mais pas son parent " + nodes[nodes[noeudCourant].getParent()].getID() + 
// 							   "... STOP");
					processed = true;
					
				    }
			    }
			else
			    // nc != label -> Pas trouve
			    // label pas extension du courant -> Pas descente
			    // nc pas extension du label
			    // -> Question: Quand est-ce qu'on remonte?
			    // On remonte si le nombre de caracteres partages par le parent est egal au nombre de caractere
			    // partages par le courant (il ne peut etre superieur) s'il est inferieur, on est dans la bonne branche
			    // mais on ne peut pas descendre donc c'est fini.
			    {

				//	System.out.println(label.getString() + " pas egale et pas extension de " + nodes[noeudCourant].getID());

				if (nodes[noeudCourant].getParent() < 0)
				    {
					System.out.println("Pas de parent... STOP");
					processed = true;
				    }
				else
				    {

					int ncc;
					int nccp;
					
					// Calcul du nombre de caracteres en commun avec le noeud courant
					for (ncc = 0; ((label.getString().length() > ncc) && (nodes[noeudCourant].getID().length() > ncc) 
						       && (label.getString().charAt(ncc) == nodes[noeudCourant].getID().charAt(ncc))); ncc++);
					
					// Calcul du nombre de caracteres en commun avec le parent du noeud courant
					for (nccp = 0; ((label.getString().length() > nccp) && (nodes[nodes[noeudCourant].getParent()].getID().length() > nccp) 
							&& (label.getString().charAt(nccp) == nodes[nodes[noeudCourant].getParent()].getID().charAt(nccp))); nccp++);

					if (ncc == nccp)
					    {
// 						System.out.println("Le parent " + nodes[nodes[noeudCourant].getParent()].getID() 
// 								   + " partage autant de caractere avec la requete " + label.getString() 
// 								   + " que le noeud courant " + nodes[noeudCourant].getID()
// 								   + ". Transmission au parent.");
						noeudCourant = nodes[noeudCourant].getParent();
						nbs++;
					    }
					else
					    {
// 						System.out.println("Le parent " + nodes[nodes[noeudCourant].getParent()].getID() 
// 								   + " partage moins de caractere avec la requete " + label.getString() 
// 								   + " que le noeud courant " + nodes[noeudCourant].getID()
// 								   + "... STOP.");
						processed = true;
						
					    }
					
				    }
			    }
		    }
		//		System.out.println("Nb Sauts: " + nbs + "\n");
		
	    }
	return (nbs);

    } // interrogeLB

    public int interroge (RandomWord label, Ring ring)
	// Renvoie l'index du noeud responsable
    {
	// compteur de sauts logiques pour cette requete
	int nbs = 0;

	// Insertion Node
	if (nbNodes == 0) // Premier noeud -> Root
	    {
		System.out.println("La TPD est vide... STOP");
	    }
	else
	    {
		boolean processed = false;
		Random entry = new Random();
		int noeudCourant = entry.nextInt(nbNodes);
		
		while (!processed)
		    {
			nodes[noeudCourant].incLoad();

			if (label.getString().compareTo(nodes[noeudCourant].getID()) == 0)
			    {
				processed = true;
// 				System.out.println ("Le noeud courant est: " + nodes[noeudCourant].getID());
// 				System.out.println("TROUVE.");

			    }
			else if (label.getString().startsWith(nodes[noeudCourant].getID()))
			    // Nouveau extension du courant (extension string vide ca marche)
			    {
				// Calcul de la taille du courant
				int tailleCourant = nodes[noeudCourant].getID().length();

				// Recherche d'un fils qui partage un caractere supplementaire				
				//	System.out.println(label.getString() + " extension de " + nodes[noeudCourant].getID());
				boolean forwarded = false;
				for (int f = 0; f < nodes[noeudCourant].getNbChildren(); f++)
				    {
					//	System.out.println("Test du fils: " + nodes[nodes[noeudCourant].getThisChild(f)].getID());
					if ((nodes[noeudCourant].getThisChild(f) != -1) && (label.getString().charAt(tailleCourant) == 
					      nodes[nodes[noeudCourant].getThisChild(f)].getID().charAt(tailleCourant)))
					    // Trouve fils du courant partageant plus de caractere que le courant
					    {
// 						System.out.println("Transmission de: " + label.getString() 
// 								   + " a: " + nodes[nodes[noeudCourant].getThisChild(f)].getID());
						noeudCourant = nodes[noeudCourant].getThisChild(f);
						forwarded = true;
						nbs++;
						break;
					    }
				    }
				if ((!forwarded) && (label.getString().compareTo(nodes[noeudCourant].getID()) != 0))
				    // Nouveau extension du courant, pas de fils mieux. STOP
				    {
					// System.out.println (nodes[noeudCourant].getID() + " n'a pas de fils pour transmettre la requete " + 
// 							    label.getString() + "... STOP!");
					processed = true;
				    }
			    }
			else if (nodes[noeudCourant].getID().startsWith(label.getString()))
			    // Courant extension du nouveau -> Au dessus
			    // Je transmets a mon parent que s'il prefixe aussi
			    {
// 				System.out.println("Le courant " + nodes[noeudCourant].getID() + 
// 						   " est une extension du nouveau " + label.getString());
				
				if (nodes[noeudCourant].getParent() < 0)
				    { 
// 					System.out.println("Je ne peux ni descendre ni monter... STOP");
 					processed = true;
				    }
				else if (nodes[nodes[noeudCourant].getParent()].getID().startsWith(label.getString()))
				    {
// 					System.out.println("Transmission au parent " + nodes[nodes[noeudCourant].getParent()].getID() + 
// 							   " qui est aussi prefixe par " + label.getString());
					noeudCourant = nodes[noeudCourant].getParent();
					nbs++;
				    }
				else
				    // Je suis prefixe mais pas mon parent
				    {
// 					System.out.println("Le noeud courant " + nodes[noeudCourant].getID() + 
// 							   " est prefixe par le nouveau " + label.getString() + 
// 							   " mais pas son parent " + nodes[nodes[noeudCourant].getParent()].getID() + 
// 							   "... STOP");
					processed = true;
					
				    }
			    }
			else
			    // nc != label -> Pas trouve
			    // label pas extension du courant -> Pas descente
			    // nc pas extension du label
			    // -> Question: Quand est-ce qu'on remonte?
			    // On remonte si le nombre de caracteres partages par le parent est egal au nombre de caractere
			    // partages par le courant (il ne peut etre superieur) s'il est inferieur, on est dans la bonne branche
			    // mais on ne peut pas descendre donc c'est fini.
			    {

				//	System.out.println(label.getString() + " pas egale et pas extension de " + nodes[noeudCourant].getID());

				if (nodes[noeudCourant].getParent() < 0)
				    {
					System.out.println("Pas de parent... STOP");
					processed = true;
				    }
				else
				    {

					int ncc;
					int nccp;
					
					// Calcul du nombre de caracteres en commun avec le noeud courant
					for (ncc = 0; ((label.getString().length() > ncc) && (nodes[noeudCourant].getID().length() > ncc) 
						       && (label.getString().charAt(ncc) == nodes[noeudCourant].getID().charAt(ncc))); ncc++);
					
					// Calcul du nombre de caracteres en commun avec le parent du noeud courant
					for (nccp = 0; ((label.getString().length() > nccp) && (nodes[nodes[noeudCourant].getParent()].getID().length() > nccp) 
							&& (label.getString().charAt(nccp) == nodes[nodes[noeudCourant].getParent()].getID().charAt(nccp))); nccp++);

					if (ncc == nccp)
					    {
// 						System.out.println("Le parent " + nodes[nodes[noeudCourant].getParent()].getID() 
// 								   + " partage autant de caractere avec la requete " + label.getString() 
// 								   + " que le noeud courant " + nodes[noeudCourant].getID()
// 								   + ". Transmission au parent.");
						noeudCourant = nodes[noeudCourant].getParent();
						nbs++;
					    }
					else
					    {
// 						System.out.println("Le parent " + nodes[nodes[noeudCourant].getParent()].getID() 
// 								   + " partage moins de caractere avec la requete " + label.getString() 
// 								   + " que le noeud courant " + nodes[noeudCourant].getID()
// 								   + "... STOP.");
						processed = true;
						
					    }
					
				    }
			    }
				  
		    }
		//		System.out.println("Nb Sauts: " + nbs + "\n");
		
	    }
	return (nbs);

    } // interroge

    public double computeClustering()
    {
	int interne = 0;
	int total = 0;
	
	for (int i = 0; i < getNbNodes(); i++)
	    {
		int [] fils = nodes[i].getChildren();
		for (int j = 0; j < nodes[i].getNbChildren(); j++)
		    {
			total++;
			if (nodes[i].getPeer() == nodes[fils[j]].getPeer())
			    {
				System.out.println(nodes[i].getID() + " et " + nodes[fils[j]].getID() + " sur le pair "+ nodes[fils[j]].getPeer());
				interne++;
			    }
			
		    }
	    }
	System.out.println("interne: " + interne);
	System.out.println("total: " + total);
	return((double)interne/(double)total);

    } //computeClustering
    
    public void setLoads()
    {
	// Si on veut une gaussienne, il faudra dnormaliser (nextGaussian)
	// Sinon uniforme
	// - nextInt avec min et max
	int min = 50; // Random
	int max = 200; // Random
	// nextDouble entre 0 et 1, adapter
	Random r = new Random();
	for (int i = 0; i < getNbNodes(); i++)
	    {
	 	nodes[i].setLoad(r.nextInt(max-min) + min); 
	   }
	
    } // setLoads    

    public void resetLoads()
    {
	for (int i = 0; i < nbNodes; i++)
	    {
		nodes[i].resetLoad();
	    }
    }
    
} // Nodes
